/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    :   adslMIB.h
 * Author       :   Subramani
 * Date         :   17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      :   Amazon
 * Block        :   ADSL-MIBs
 *
 * ===========================================================================
 * Contents:  This file contains the command 'config_require' and module names
 *            which will be used the configure script to generate a Makefile.
 *            This file is used by the configure script to load the different
 *            modules under adslMIB directory for compilation.
 *
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */



/* ===========================================================================
 * Revision History:
 *
 * $Log$
 * ===========================================================================
*/

// This file is included in the mibgroup directory to add the various modules
// of adsl

config_require(adslMIB/adslTable_access)

config_require(adslMIB/adslLineTable/adslLineTable)
config_require(adslMIB/adslAtucChanIntervalTable/adslAtucChanIntervalTable)
config_require(adslMIB/adslAtucChanPerfDataTable/adslAtucChanPerfDataTable)
config_require(adslMIB/adslAtucChanTable/adslAtucChanTable)
config_require(adslMIB/adslAtucIntervalTable/adslAtucIntervalTable)
config_require(adslMIB/adslAtucPerfDataTable/adslAtucPerfDataTable)
config_require(adslMIB/adslAtucPhysTable/adslAtucPhysTable)

config_require(adslMIB/adslAturChanIntervalTable/adslAturChanIntervalTable)
config_require(adslMIB/adslAturChanPerfDataTable/adslAturChanPerfDataTable)
config_require(adslMIB/adslAturChanTable/adslAturChanTable)
config_require(adslMIB/adslAturIntervalTable/adslAturIntervalTable)
config_require(adslMIB/adslAturPerfDataTable/adslAturPerfDataTable)
config_require(adslMIB/adslAturPhysTable/adslAturPhysTable)

config_require(adslMIB/adslLineAlarmConfProfileTable/adslLineAlarmConfProfileTable)

config_require(adslMIB/adslTraps/adslTraps)

config_add_mib(ADSL-LINE-MIB)

