/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    :   adslAtucChanIntervalTable_access.h
 * Author       :   Subramani
 * Date         :   17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      :   Amazon
 * Block        :   ADSL-MIBs
 *
 * ===========================================================================
 * Contents: This file contains :
 *              1)  Include files
 *              2)  User defined data types
 *              3)  Function proto-types for adslAtucChanIntervalTable_access
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */



/* ===========================================================================
 * Revision History:
 *
 * $Log$
 * ===========================================================================
 */


/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */

#ifndef ADSLATUCCHANINTERVALTABLE_ACCESS_H
#define ADSLATUCCHANINTERVALTABLE_ACCESS_H

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
*/
#include <adslMIB/adslTable_access.h>


/*
 * ===========================================================================
 *                        USER-DEFINED DATA TYPES
 * ===========================================================================
*/

#ifdef STUB_IOCTL
/** User-defined data structure for accessing adslAtucIntervalTable **/

typedef u_int32 PerfIntervalCount;

typedef struct adslAtucChanIntvlInfo {
    int ifIndex;
    int IntervalNumber;
    PerfIntervalCount chanIntervalRecvdBlks;
    PerfIntervalCount chanIntervalXmitBlks;
    PerfIntervalCount chanIntervalCorrectedBlks;
    PerfIntervalCount chanIntervalUncorrectBlks;
    int intervalValidData;
    u_char flags;
} adslAtucChanIntvlInfo;
#endif

/*
 * ===========================================================================
 *                           FUNCTION PROTOTYPES
 * ===========================================================================
*/

/** User-defined data access functions for data in table
    adslAtucChanIntervalTable */

/** row level accessors */
Netsnmp_First_Data_Point adslAtucChanIntervalTable_get_first_data_point;
Netsnmp_Next_Data_Point adslAtucChanIntervalTable_get_next_data_point;


/** column accessors */
#if defined(HAVE_OPTIMIZED_CODE)
u_int32  *
get_adslAtucChanIntervalData(void *data_context, size_t * ret_len, 
		unsigned int var);
#else
u_int32  *get_adslAtucChanIntervalReceivedBlks(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAtucChanIntervalTransmittedBlks(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAtucChanIntervalCorrectedBlks(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAtucChanIntervalUncorrectBlks(void *data_context,
            size_t * ret_len);
#endif

int     *get_adslAtucChanIntervalValidData(void *data_context,
            size_t * ret_len);

#ifndef ENABLE_DRIVER_CALL
int  get_adslAtucChanIntervalTable(int Fd2,int GET_ADSL_atuc_CHAN_INTVL_INFO,
     void *adslAtucChanIntvlTable);
#endif

#endif                          /* ADSLATUCCHANINTERVALTABLE_ACCESS_H */
