/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    :   adslAtucChanPerfDataTable_access.h
 * Author       :   Subramani
 * Date         :   17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      :   Amazon
 * Block        :   ADSL-MIBs
 *
 * ===========================================================================
 * Contents: This file contains :
 *              1)  Include files
 *              2)  User defined data types
 *              3)  Function proto-types for adslAtucChanPerfDataTable_access
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */



/* ===========================================================================
 * Revision History:
 *  Subramani: Return types of get_adslAtucChanPerfValidIntervals,
 *  get_adslAtucChanPerfInvalidIntervals and
 *  get_adslAtucChanPerfPrev1DayMoniSecs are changed from long to int
 *
 * $Log$
 * ===========================================================================
 */


/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */
//#include <adslMIBincl.h>


#ifndef ADSLATUCCHANPERFDATATABLE_ACCESS_H
#define ADSLATUCCHANPERFDATATABLE_ACCESS_H

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
*/

#include <adslMIB/adslTable_access.h>

/*
 * ===========================================================================
 *                        USER-DEFINED DATA TYPES
 * ===========================================================================
*/

#ifdef STUB_IOCTL
/** User-defined data structure for accessing adslAtucChanPerfDataTable **/

#define AdslPerfTimeElapsed u_int32
#define PerfCurrentCount u_int32
#define AdslPerfCurrDayCount u_int32
#define AdslPerfPrevDayCount u_int32

typedef struct atucChannelPerfDataEntry
{
   int          ifIndex;
   u_int32          adslAtucChanReceivedBlks;
   u_int32          adslAtucChanTransmittedBlks;
   u_int32          adslAtucChanCorrectedBlks;
   u_int32          adslAtucChanUncorrectBlks;
   int              adslAtucChanPerfValidIntervals;
   int              adslAtucChanPerfInvalidIntervals;
   AdslPerfTimeElapsed  adslAtucChanPerfCurr15MinTimeElapsed;
   PerfCurrentCount     adslAtucChanPerfCurr15MinReceivedBlks;
   PerfCurrentCount     adslAtucChanPerfCurr15MinTransmittedBlks;
   PerfCurrentCount     adslAtucChanPerfCurr15MinCorrectedBlks;
   PerfCurrentCount     adslAtucChanPerfCurr15MinUncorrectBlks;
   AdslPerfTimeElapsed  adslAtucChanPerfCurr1DayTimeElapsed;
   AdslPerfCurrDayCount adslAtucChanPerfCurr1DayReceivedBlks;
   AdslPerfCurrDayCount adslAtucChanPerfCurr1DayTransmittedBlks;
   AdslPerfCurrDayCount adslAtucChanPerfCurr1DayCorrectedBlks;
   AdslPerfCurrDayCount adslAtucChanPerfCurr1DayUncorrectBlks;
   int                  adslAtucChanPerfPrev1DayMoniSecs;
   AdslPerfPrevDayCount adslAtucChanPerfPrev1DayReceivedBlks;
   AdslPerfPrevDayCount adslAtucChanPerfPrev1DayTransmittedBlks;
   AdslPerfPrevDayCount adslAtucChanPerfPrev1DayCorrectedBlks;
   AdslPerfPrevDayCount adslAtucChanPerfPrev1DayUncorrectBlks;
   u_int32          flags;
}atucChannelPerfDataEntry;
#endif

/*
 * ===========================================================================
 *                           FUNCTION PROTOTYPES
 * ===========================================================================
*/

/** User-defined data access functions for data in table
    adslAtucChanPerfDataTable */
/** row level accessors */
Netsnmp_First_Data_Point adslAtucChanPerfDataTable_get_first_data_point;
Netsnmp_Next_Data_Point adslAtucChanPerfDataTable_get_next_data_point;



/** column accessors */
#if defined(HAVE_OPTIMIZED_CODE)
u_int32  *
get_adslAtucChanBlksData(void *data_context, size_t * ret_len,
			unsigned int var);

int *
get_adslAtucChanPerfIntervalData(void *data_context, size_t * ret_len,
			unsigned int var);

u_int32  *
get_adslAtucChanPerfStatsData(void *data_context, size_t * ret_len,
			unsigned int var);
#else
u_int32  *get_adslAtucChanReceivedBlks(void *data_context, size_t * ret_len);
u_int32  *get_adslAtucChanTransmittedBlks(void *data_context, size_t * ret_len);
u_int32  *get_adslAtucChanCorrectedBlks(void *data_context, size_t * ret_len);
u_int32  *get_adslAtucChanUncorrectBlks(void *data_context, size_t * ret_len);
int     *get_adslAtucChanPerfValidIntervals(void *data_context,
            size_t * ret_len);
int     *get_adslAtucChanPerfInvalidIntervals(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAtucChanPerfCurr15MinTimeElapsed(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAtucChanPerfCurr15MinReceivedBlks(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAtucChanPerfCurr15MinTransmittedBlks(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAtucChanPerfCurr15MinCorrectedBlks(void *data_context,
             size_t * ret_len);
u_int32  *get_adslAtucChanPerfCurr15MinUncorrectBlks(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAtucChanPerfCurr1DayTimeElapsed(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAtucChanPerfCurr1DayReceivedBlks(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAtucChanPerfCurr1DayTransmittedBlks(void *data_context,
            size_t *ret_len);
u_int32  *get_adslAtucChanPerfCurr1DayCorrectedBlks(void *data_context,
            size_t *ret_len);
u_int32  *get_adslAtucChanPerfCurr1DayUncorrectBlks(void *data_context,
            size_t *ret_len);
int     *get_adslAtucChanPerfPrev1DayMoniSecs(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAtucChanPerfPrev1DayReceivedBlks(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAtucChanPerfPrev1DayTransmittedBlks(void *data_context,
            size_t *ret_len);
u_int32  *get_adslAtucChanPerfPrev1DayCorrectedBlks(void *data_context,
            size_t *ret_len);
u_int32  *get_adslAtucChanPerfPrev1DayUncorrectBlks(void *data_context,
            size_t *ret_len);
#endif


#ifndef ENABLE_DRIVER_CALL
int get_adslAtucChanPerfDataTable(int Fd2,int GET_adsl_ATUC_CHAN_PERF_DATA2,
            void *atucChanPerfDataValue);
#endif

#endif                          /* ADSLATUCCHANPERFDATATABLE_ACCESS_H */
