/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-LAN-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxPppoeConfTable_access.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.9 2004/10/14 12:57:33 dts12 Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "ifxPppoeConfTable_access.h"

/*
 * ===========================================================================
 *                          GLOBAL DEFINITIONS
 * ===========================================================================
*/
static char                 cRetVal[MAX_DATA_LEN];
static unsigned int         nEntryNum = 1;

/*
 * ===========================================================================
 *                          LOCAL FUNCTIONS
 * ===========================================================================
*/
netsnmp_variable_list *
ifxPppoeConfTable_set_indexes(PPPOECFG_S *datainfo,
                              netsnmp_variable_list *put_index_data)
{
    /* printf("**** ifxPppoeConfTable_set_indexes ****\n"); */
    netsnmp_variable_list   *vptr;

    vptr = put_index_data;
    snmp_set_var_value(vptr, (u_char *) &datainfo->index,
                       sizeof(datainfo->index) );

    return put_index_data;
}

PPPOECFG_S  **
ifxPppoeConfTable_get_data(void)
{
    int              i = 0;

    if (nEntryNum > 0)
    {
        memset (&xMibMsg, 0x00, sizeof(IFX_MIB_MSG_S));
        xMibMsg.nType = IFX_MIB_WAN_PPPOE;
        xMibMsg.nCount = nEntryNum;
        xMibMsg.nPSize = sizeof(PPPOECFG_S *);
        xMibMsg.nSize = sizeof(PPPOECFG_S);

        ifx_MIB_Dalloc();
	}

    for ( i = 0; i < nEntryNum; i++)
    {
        memset (&cRetVal, 0x00, MAX_DATA_LEN);
        pstWanPppoeCfg[i]->index = i;
    
        if ( ifx_GetCfgData(FILE_RC_CONF, "wan_pppoe", "PPPOE_USERNAME",
                            cRetVal) != 1 )
        {
            DEBUGMSGTL(("snmpd", "unable get WAN PPPoE User Name\n"));
    	}
    	strcpy (pstWanPppoeCfg[i]->cPppoeUserName, cRetVal);
    
        memset (&cRetVal, 0x00, MAX_DATA_LEN);
    
        if ( ifx_GetCfgData(FILE_RC_CONF, "wan_pppoe", "PPPOE_PASSWORD",
                            cRetVal) != 1 )
        {
            DEBUGMSGTL(("snmpd", "unable get WAN PPPoE Password\n"));
    	}
    	strcpy (pstWanPppoeCfg[i]->cPppoePasswd, cRetVal);
    
        memset (&cRetVal, 0x00, MAX_DATA_LEN);
    
        if ( ifx_GetCfgData(FILE_RC_CONF, "wan_pppoe", "PPPOE_SERVICENAME",
                            cRetVal) != 1 )
        {
            DEBUGMSGTL(("snmpd", "unable get WAN PPPoE ISP\n"));
    	}
    	strcpy (pstWanPppoeCfg[i]->cPppoeISP, cRetVal);
    
        memset (&cRetVal, 0x00, MAX_DATA_LEN);
    
        if ( ifx_GetCfgData(FILE_RC_CONF, "wan_pppoe", "PPPOE_AUTH_TYPE",
                            cRetVal) != 1 )
        {
            DEBUGMSGTL(("snmpd", "unable get WAN PPPoE Authentication Type\n"));
    	}

        if (!strcmp (cRetVal, "pap"))
    	    pstWanPppoeCfg[i]->ulPppoeAuthType = IFX_CM_PPPOE_PAP;
        else
    	    pstWanPppoeCfg[i]->ulPppoeAuthType = IFX_CM_PPPOE_CHAP;
    }
}

/** returns the first data point within the ifxPppoeConfTable table data.

    Set the my_loop_context variable to the first data point structure
    of your choice (from which you can find the next one).  This could
    be anything from the first node in a linked list, to an integer
    pointer containing the beginning of an array variable.

    Set the my_data_context variable to something to be returned to
    you later that will provide you with the data to return in a given
    row.  This could be the same pointer as what my_loop_context is
    set to, or something different.

    The put_index_data variable contains a list of snmp variable
    bindings, one for each index in your table.  Set the values of
    each appropriately according to the data matching the first row
    and return the put_index_data variable at the end of the function.
*/
netsnmp_variable_list *
ifxPppoeConfTable_get_first_data_point(void **my_loop_context,
                                       void **my_data_context,
                                       netsnmp_variable_list *
                                       put_index_data,
                                       netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxPppoeConfTable_get_first_data_point ****\n"); */
    int     *position;

    /* we could do this with a file-static variable, but for learning
       purposes we'll use memory allocation to demonstrate simplistic
       freeing of a loop_context */
    position = (int *)malloc(sizeof(int));
    if (!position)
        return NULL;

    ifxPppoeConfTable_get_data();

    if (!pstWanPppoeCfg)
    {
        snmp_log(LOG_ERR, "ifxPppoeConfTable: None of row for this table.\n");
        free(position);
        return NULL;
    }

    /* We use the positinonal count as our loop context */
    *position = 0;
    *my_loop_context = position;

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = pstWanPppoeCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxPppoeConfTable_set_indexes(pstWanPppoeCfg[*position], put_index_data);
}

/** functionally the same as ifxPppoeConfTable_get_first_data_point, but
   my_loop_context has already been set to a previous value and should
   be updated to the next in the list.  For example, if it was a
   linked list, you might want to cast it to your local data type and
   then return my_loop_context->next.  The my_data_context pointer
   should be set to something you need later and the indexes in
   put_index_data updated again. */
netsnmp_variable_list *
ifxPppoeConfTable_get_next_data_point(void **my_loop_context,
                                      void **my_data_context,
                                      netsnmp_variable_list *
                                      put_index_data,
                                      netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxPppoeConfTable_get_next_data_point ****\n"); */
    int *position = (int *) *my_loop_context;

    /* make sure we were called correctly */
    if (!position)
        return NULL;
    
    /* go to the next entry in the list */
    (*position)++;

    /* Are we beyond the end? */
    if (*position >= nEntryNum)
    {
        /* End of entry.  stop here by returning NULL */
        free(position);
        *my_loop_context = NULL;
        *my_data_context = NULL;
        return NULL;
    }

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = pstWanPppoeCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxPppoeConfTable_set_indexes(pstWanPppoeCfg[*position], put_index_data);
}

/** Create a data_context for non-existent rows that SETs are performed on.
 *  return a void * pointer which will be passed to subsequent get_XXX
 *  and set_XXX functions for data retrival and modification during
 *  this SET request.
 *
 *  The indexs are encoded (in order) into the index_data pointer if it
 *  would be helpful to use that information.
 */
void           *
ifxPppoeConfTable_create_data_context(netsnmp_variable_list *index_data,
                                      int column)
{
    return NULL;                /* XXX: you likely want to return a real pointer */
}

/** If the implemented set_* functions don't operate directly on the
   real-live data (which is actually recommended), then this function
   can be used to take a given my_data_context pointer and "commit" it
   to whereever the modified data needs to be put back to.  For
   example, if this was a routing table you could publish the modified
   routes back into the kernel at this point.

   new_or_del will be set to 1 if new, or -1 if it should be deleted
   or 0 if it is just a modification of an existing row.

   If you free the data yourself, make sure to *my_data_context = NULL */
int
ifxPppoeConfTable_commit_row(void **my_data_context, int new_or_del)
{
    PPPOECFG_S              *datactx = *my_data_context;
    char                    sCommand[MAX_DATA_LEN];
    char                    sUserName[MAX_DATA_LEN];
    char                    sPasswd[MAX_DATA_LEN];
	char                    sMTU[MAX_DATA_LEN];
    char                    sISP[MAX_DATA_LEN];
    char                    sDemand[MAX_DATA_LEN];
    char                    sIdle[MAX_DATA_LEN];
    char                    sAuthType[MAX_DATA_LEN];
    int                     nSetReturn = -1;
    x_IFX_CM_Msg            xCmMsg;

    /* printf("**** ifxPppoeConfTable_commit_row ****\n"); */

    if (new_or_del == -1)
    {
        return SNMP_ERR_NOERROR; /* no change in the value */
    }

    memset (&sCommand, 0x00, MAX_DATA_LEN);
    memset (&sUserName, 0x00, MAX_DATA_LEN);
    memset (&sPasswd, 0x00, MAX_DATA_LEN);
    memset (&sMTU, 0x00, MAX_DATA_LEN);
    memset (&sISP, 0x00, MAX_DATA_LEN);
    memset (&sDemand, 0x00, MAX_DATA_LEN);
    memset (&sIdle, 0x00, MAX_DATA_LEN);
    memset (&sAuthType, 0x00, MAX_DATA_LEN);

    sprintf (sUserName, "PPPOE_USERNAME=\"%s\"\n", datactx->cPppoeUserName);
    sprintf (sPasswd, "PPPOE_PASSWORD=\"%s\"\n", datactx->cPppoePasswd);
    sprintf (sMTU, "PPPOE_MTU=\"1492\"\n");
    sprintf (sISP, "PPPOE_SERVICENAME=\"%s\"\n", datactx->cPppoeISP);
    sprintf (sDemand, "PPPOE_DEMAND=0\n");
    sprintf (sIdle, "PPPOE_IDLE=0\n");
    if (datactx->ulPppoeAuthType == IFX_CM_PPPOE_PAP)
        sprintf (sAuthType, "PPPOE_AUTH_TYPE=\"pap\"\n");
    else
        sprintf (sAuthType, "PPPOE_AUTH_TYPE=\"chap\"\n");

    nSetReturn = websSetCfgData(FILE_RC_CONF, "wan_pppoe", 7, sUserName,
                   sPasswd, sMTU, sISP, sDemand, sIdle, sAuthType);

    if (nSetReturn != 1)
    {
        return SNMP_ERR_COMMITFAILED;
    }

#if defined(ATA) || defined(IIP)
    /* Populate the structure of CM*/
    memset(&xCmMsg, 0, sizeof(x_IFX_CM_Msg));
    xCmMsg.ucMsgType = IFX_CM_SET_REQ;
    xCmMsg.ucInfoType = IFX_CM_APP_NETWORK;
    xCmMsg.uxData.xNetAddrCfg.ucWanIfType = IFX_CM_WAN_IF_PPPOE;
    xCmMsg.ucChannel =0;

    strcpy(xCmMsg.uxData.xNetAddrCfg.xPppoeCfg.acUserName, datactx->cPppoeUserName);
    strcpy(xCmMsg.uxData.xNetAddrCfg.xPppoeCfg.acPasswd, datactx->cPppoePasswd);
    strcpy(xCmMsg.uxData.xNetAddrCfg.xPppoeCfg.acServProv, datactx->cPppoeISP);
    xCmMsg.uxData.xNetAddrCfg.xPppoeCfg.ucAuthType = datactx->ulPppoeAuthType;

    snmp_log(LOG_ERR, "ifxPppoeConfTable: CM will do reboot.\n");

    if (IFX_CM_SendDataToCM(&xCmMsg) != IFX_CM_SUCCESS)
    {
    	return SNMP_ERR_COMMITFAILED;
    }
#endif
}


/*
 * User-defined data access functions (per column) for data in table ifxPppoeConfTable 
 */
/*
 * NOTE:
 * - these get_ routines MUST return data that will not be freed (ie,
 *   use static variables or persistent data).  It will be copied, if
 *   needed, immediately after the get_ routine has been called.
 * - these SET routines must copy the incoming data and can not take
 *   ownership of the memory passed in by the val pointer.
 */
/** XXX: return a data pointer to the data for the pppoeUserName column and set
         ret_len to its proper size in bytes. */
char           *
get_pppoeUserName(void *data_context, size_t * ret_len)
{
    PPPOECFG_S   *datainfo = data_context;
	*ret_len = strlen(datainfo->cPppoeUserName);
    return (char *) &datainfo->cPppoeUserName;
}

/** XXX: Set the value of the pppoeUserName column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_pppoeUserName(void *data_context, char *val, size_t val_len)
{
    PPPOECFG_S *datainfo = data_context;
    memset(&datainfo->cPppoeUserName, 0x00, sizeof(datainfo->cPppoeUserName));
    memcpy(&datainfo->cPppoeUserName, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the pppoePasswd column and set
         ret_len to its proper size in bytes. */
char           *
get_pppoePasswd(void *data_context, size_t * ret_len)
{
    PPPOECFG_S   *datainfo = data_context;
	*ret_len = strlen(datainfo->cPppoePasswd);
    return (char *) &datainfo->cPppoePasswd;
}

/** XXX: Set the value of the pppoePasswd column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_pppoePasswd(void *data_context, char *val, size_t val_len)
{
    PPPOECFG_S *datainfo = data_context;
    memset(&datainfo->cPppoePasswd, 0x00, sizeof(datainfo->cPppoePasswd));
    memcpy(&datainfo->cPppoePasswd, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the pppoeISP column and set
         ret_len to its proper size in bytes. */
char           *
get_pppoeISP(void *data_context, size_t * ret_len)
{
    PPPOECFG_S   *datainfo = data_context;
	*ret_len = strlen(datainfo->cPppoeISP);
    return (char *) &datainfo->cPppoeISP;
}

/** XXX: Set the value of the pppoeISP column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_pppoeISP(void *data_context, char *val, size_t val_len)
{
    PPPOECFG_S *datainfo = data_context;
    memset(&datainfo->cPppoeISP, 0x00, sizeof(datainfo->cPppoeISP));
    memcpy(&datainfo->cPppoeISP, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the pppoeAuthType column and set
         ret_len to its proper size in bytes. */
u_long         *
get_pppoeAuthType(void *data_context, size_t * ret_len)
{
    PPPOECFG_S *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulPppoeAuthType);
    return &datainfo->ulPppoeAuthType;
}

/** XXX: Set the value of the pppoeAuthType column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_pppoeAuthType(void *data_context, u_long * val, size_t val_len)
{
    PPPOECFG_S *datainfo = data_context;
    datainfo->ulPppoeAuthType = 0;
    memcpy(&datainfo->ulPppoeAuthType, val, val_len);
    return SNMP_ERR_NOERROR;
}
