/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-QOS-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxExtendQosTable_access.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include <stdlib.h>
#include "ifxExtendQosTable_access.h"

/*
 * ===========================================================================
 *                          GLOBAL DEFINITIONS
 * ===========================================================================
*/
static char                 cRetVal[MAX_DATA_LEN];
static unsigned int         nEntryNum = 1;

/*
 * ===========================================================================
 *                          LOCAL FUNCTIONS
 * ===========================================================================
*/
netsnmp_variable_list *
ifxExtendQosTable_set_indexes(QOSEXTENDCFG_S *datainfo,
                              netsnmp_variable_list *put_index_data)
{
    /* printf("**** ifxExtendQosTable_set_indexes ****\n"); */
    netsnmp_variable_list   *vptr;

    vptr = put_index_data;
    snmp_set_var_value(vptr, (u_char *) &datainfo->index,
                       sizeof(datainfo->index) );

    return put_index_data;
}

QOSEXTENDCFG_S  **
ifxExtendQosTable_get_data(void)
{
    int              i = 0;

    if (nEntryNum > 0)
    {
        memset (&xMibMsg, 0x00, sizeof(IFX_MIB_MSG_S));
        xMibMsg.nType = IFX_MIB_QOS_EXTEND;
        xMibMsg.nCount = nEntryNum;
        xMibMsg.nPSize = sizeof(QOSEXTENDCFG_S *);
        xMibMsg.nSize = sizeof(QOSEXTENDCFG_S);

        ifx_MIB_Dalloc();
	}

    for ( i = 0; i < nEntryNum; i++)
    {
        pstQosExtendCfg[i]->index = i;
    
        memset (&cRetVal, 0x00, MAX_DATA_LEN);
    
    	if (ifx_GetCfgData(FILE_RC_CONF, "extension_priority", "management",
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get nMgtPrio\n"));
    	}
    	pstQosExtendCfg[i]->nMgtPrio = atoi(cRetVal);

        memset (&cRetVal, 0x00, MAX_DATA_LEN);
    
    	if (ifx_GetCfgData(FILE_RC_CONF, "extension_priority", "mgn_vid",
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get nMgtId\n"));
    	}
    	pstQosExtendCfg[i]->nMgtId = atoi(cRetVal);
    
        memset (&cRetVal, 0x00, MAX_DATA_LEN);
    
    	if (ifx_GetCfgData(FILE_RC_CONF, "dscp_tos_priority", "dt_management",
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get cMgtData\n"));
    	}
    	strcpy (pstQosExtendCfg[i]->cMgtData, cRetVal);
    
        memset (&cRetVal, 0x00, MAX_DATA_LEN);
    
    	if (ifx_GetCfgData(FILE_RC_CONF, "extension_priority", "voip",
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get nVoipPrio\n"));
    	}
    	pstQosExtendCfg[i]->nVoipPrio = atoi(cRetVal);
    
        memset (&cRetVal, 0x00, MAX_DATA_LEN);
    
    	if (ifx_GetCfgData(FILE_RC_CONF, "extension_priority", "voip_vid",
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get nVoipId\n"));
    	}
    	pstQosExtendCfg[i]->nVoipId = atoi(cRetVal);
    
        memset (&cRetVal, 0x00, MAX_DATA_LEN);
    
    	if (ifx_GetCfgData(FILE_RC_CONF, "dscp_tos_priority", "dt_voip",
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get cVoipData\n"));
    	}
    	strcpy (pstQosExtendCfg[i]->cVoipData, cRetVal);
    
        memset (&cRetVal, 0x00, MAX_DATA_LEN);
    
    	if (ifx_GetCfgData(FILE_RC_CONF, "extension_priority", "signaling",
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get nSignalPrio\n"));
    	}
    	pstQosExtendCfg[i]->nSignalPrio = atoi(cRetVal);
    
        memset (&cRetVal, 0x00, MAX_DATA_LEN);
    
    	if (ifx_GetCfgData(FILE_RC_CONF, "extension_priority", "sgl_vid",
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get nSignalId\n"));
    	}
    	pstQosExtendCfg[i]->nSignalId = atoi(cRetVal);
    
        memset (&cRetVal, 0x00, MAX_DATA_LEN);
    
    	if (ifx_GetCfgData(FILE_RC_CONF, "dscp_tos_priority", "dt_signaling",
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get cSignalData\n"));
    	}
        strcpy (pstQosExtendCfg[i]->cSignalData, cRetVal);
    
        memset (&cRetVal, 0x00, MAX_DATA_LEN);
    
    	if (ifx_GetCfgData(FILE_RC_CONF, "extension_priority", "data",
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get nOtherPrio\n"));
    	}
    	pstQosExtendCfg[i]->nOtherPrio = atoi(cRetVal);
    
        memset (&cRetVal, 0x00, MAX_DATA_LEN);
    
    	if (ifx_GetCfgData(FILE_RC_CONF, "extension_priority", "data_vid",
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get nOtherId\n"));
    	}
    	pstQosExtendCfg[i]->nOtherId = atoi(cRetVal);
    
        memset (&cRetVal, 0x00, MAX_DATA_LEN);
    
    	if (ifx_GetCfgData(FILE_RC_CONF, "dscp_tos_priority", "dt_data",
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get cOtherData\n"));
    	}
    	strcpy (pstQosExtendCfg[i]->cOtherData, cRetVal);
    }
}

/** returns the first data point within the ifxExtendQosTable table data.

    Set the my_loop_context variable to the first data point structure
    of your choice (from which you can find the next one).  This could
    be anything from the first node in a linked list, to an integer
    pointer containing the beginning of an array variable.

    Set the my_data_context variable to something to be returned to
    you later that will provide you with the data to return in a given
    row.  This could be the same pointer as what my_loop_context is
    set to, or something different.

    The put_index_data variable contains a list of snmp variable
    bindings, one for each index in your table.  Set the values of
    each appropriately according to the data matching the first row
    and return the put_index_data variable at the end of the function.
*/
netsnmp_variable_list *
ifxExtendQosTable_get_first_data_point(void **my_loop_context,
                                       void **my_data_context,
                                       netsnmp_variable_list *
                                       put_index_data,
                                       netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxExtendQosTable_get_first_data_point ****\n"); */
    int     *position;

    /* we could do this with a file-static variable, but for learning
       purposes we'll use memory allocation to demonstrate simplistic
       freeing of a loop_context */
    position = (int *)malloc(sizeof(int));
    if (!position)
        return NULL;

    ifxExtendQosTable_get_data();

    if (!pstQosExtendCfg)
    {
        snmp_log(LOG_ERR, "ifxExtendQosTable: None of row for this table.\n");
        free(position);
        return NULL;
    }

    /* We use the positinonal count as our loop context */
    *position = 0;
    *my_loop_context = position;

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = pstQosExtendCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxExtendQosTable_set_indexes(pstQosExtendCfg[*position], put_index_data);
}

/** functionally the same as ifxExtendQosTable_get_first_data_point, but
   my_loop_context has already been set to a previous value and should
   be updated to the next in the list.  For example, if it was a
   linked list, you might want to cast it to your local data type and
   then return my_loop_context->next.  The my_data_context pointer
   should be set to something you need later and the indexes in
   put_index_data updated again. */
netsnmp_variable_list *
ifxExtendQosTable_get_next_data_point(void **my_loop_context,
                                      void **my_data_context,
                                      netsnmp_variable_list *
                                      put_index_data,
                                      netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxExtendQosTable_get_next_data_point ****\n"); */
    int *position = (int *) *my_loop_context;

    /* make sure we were called correctly */
    if (!position)
        return NULL;
    
    /* go to the next entry in the list */
    (*position)++;

    /* Are we beyond the end? */
    if (*position >= nEntryNum)
    {
        /* End of entry.  stop here by returning NULL */
        free(position);
        *my_loop_context = NULL;
        *my_data_context = NULL;
        return NULL;
    }

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = pstQosExtendCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxExtendQosTable_set_indexes(pstQosExtendCfg[*position], put_index_data);
}

/** Create a data_context for non-existent rows that SETs are performed on.
 *  return a void * pointer which will be passed to subsequent get_XXX
 *  and set_XXX functions for data retrival and modification during
 *  this SET request.
 *
 *  The indexs are encoded (in order) into the index_data pointer if it
 *  would be helpful to use that information.
 */
void           *
ifxExtendQosTable_create_data_context(netsnmp_variable_list *
                                      index_data, int column)
{
    return NULL;                /* XXX: you likely want to return a real pointer */
}

/** If the implemented set_* functions don't operate directly on the
   real-live data (which is actually recommended), then this function
   can be used to take a given my_data_context pointer and "commit" it
   to whereever the modified data needs to be put back to.  For
   example, if this was a routing table you could publish the modified
   routes back into the kernel at this point.

   new_or_del will be set to 1 if new, or -1 if it should be deleted
   or 0 if it is just a modification of an existing row.

   If you free the data yourself, make sure to *my_data_context = NULL */
int
ifxExtendQosTable_commit_row(void **my_data_context, int new_or_del)
{
    QOSEXTENDCFG_S          *datactx = *my_data_context;
    char                    sExtnPrio[BUF_SIZE_1K];
    char                    sDtPrio[BUF_SIZE_1K];
    char                    sTemp[MAX_DATA_LEN];
    int                     nSetReturn = -1;

    /* printf("**** ifxExtendQosTable_commit_row ****\n"); */

    if (new_or_del == -1)
    {
        return SNMP_ERR_NOERROR; /* no change in the value */
    }

    memset (&sExtnPrio, 0x00, BUF_SIZE_1K);
    memset (&sDtPrio, 0x00, BUF_SIZE_1K);

    memset (&cRetVal, 0x00, MAX_DATA_LEN);
    memset (&sTemp, 0x00, MAX_DATA_LEN);
	if (ifx_GetCfgData(FILE_RC_CONF, "extension_priority",
	                   "stream_classification_802_1", cRetVal) != 1)
	{
        DEBUGMSGTL(("snmpd", "unable get stream_classification_802_1\n"));
	}
	sprintf(sTemp, "stream_classification_802_1=\"%s\"\n", cRetVal);
	strcat (sExtnPrio, sTemp);

    memset (&sTemp, 0x00, MAX_DATA_LEN);
    sprintf (sTemp, "management=\"%d\"\n", datactx->nMgtPrio);
	strcat (sExtnPrio, sTemp);
    memset (&sTemp, 0x00, MAX_DATA_LEN);
    sprintf (sTemp, "mgn_vid=\"%d\"\n", datactx->nMgtId);
	strcat (sExtnPrio, sTemp);
    memset (&sTemp, 0x00, MAX_DATA_LEN);
    sprintf (sTemp, "voip=\"%d\"\n", datactx->nVoipPrio);
	strcat (sExtnPrio, sTemp);
    memset (&sTemp, 0x00, MAX_DATA_LEN);
    sprintf (sTemp, "voip_vid=\"%d\"\n", datactx->nVoipId);
	strcat (sExtnPrio, sTemp);
    memset (&sTemp, 0x00, MAX_DATA_LEN);
    sprintf (sTemp, "signaling=\"%d\"\n", datactx->nSignalPrio);
	strcat (sExtnPrio, sTemp);
    memset (&sTemp, 0x00, MAX_DATA_LEN);
    sprintf (sTemp, "sgl_vid=\"%d\"\n", datactx->nSignalId);
	strcat (sExtnPrio, sTemp);
    memset (&sTemp, 0x00, MAX_DATA_LEN);
    sprintf (sTemp, "data=\"%d\"\n", datactx->nOtherPrio);
	strcat (sExtnPrio, sTemp);
    memset (&sTemp, 0x00, MAX_DATA_LEN);
    sprintf (sTemp, "data_vid=\"%d\"\n", datactx->nOtherId);
	strcat (sExtnPrio, sTemp);

    nSetReturn = websSetCfgData(FILE_RC_CONF, "extension_priority", 1, sExtnPrio);

    if (nSetReturn != 1)
    {
        return SNMP_ERR_COMMITFAILED;
    }

    memset (&cRetVal, 0x00, MAX_DATA_LEN);
    memset (&sTemp, 0x00, MAX_DATA_LEN);
	if (ifx_GetCfgData(FILE_RC_CONF, "dscp_tos_priority",
	                   "dt_priority", cRetVal) != 1)
	{
        DEBUGMSGTL(("snmpd", "unable get dt_priority\n"));
	}
	sprintf(sTemp, "dt_priority=\"%s\"\n", cRetVal);
	strcat (sDtPrio, sTemp);

    memset (&sTemp, 0x00, MAX_DATA_LEN);
    sprintf (sTemp, "dt_management=\"%s\"\n", datactx->cMgtData);
	strcat (sDtPrio, sTemp);
    memset (&sTemp, 0x00, MAX_DATA_LEN);
    sprintf (sTemp, "dt_voip=\"%s\"\n", datactx->cVoipData);
	strcat (sDtPrio, sTemp);
    memset (&sTemp, 0x00, MAX_DATA_LEN);
    sprintf (sTemp, "dt_signaling=\"%s\"\n", datactx->cSignalData);
	strcat (sDtPrio, sTemp);
    memset (&sTemp, 0x00, MAX_DATA_LEN);
    sprintf (sTemp, "dt_data=\"%s\"\n", datactx->cOtherData);
	strcat (sDtPrio, sTemp);

    nSetReturn = -1;
    nSetReturn = websSetCfgData(FILE_RC_CONF, "dscp_tos_priority", 1, sDtPrio);

    if (nSetReturn != 1)
    {
        return SNMP_ERR_COMMITFAILED;
    }

    /*
     * return no errors.  And there shouldn't be any!!!  Ever!!!  You
     * should have checked the values long before this. 
     */
    return SNMP_ERR_NOERROR;
}

/*
 * User-defined data access functions (per column) for data in table ifxExtendQosTable 
 */
/*
 * NOTE:
 * - these get_ routines MUST return data that will not be freed (ie,
 *   use static variables or persistent data).  It will be copied, if
 *   needed, immediately after the get_ routine has been called.
 * - these SET routines must copy the incoming data and can not take
 *   ownership of the memory passed in by the val pointer.
 */
/** XXX: return a data pointer to the data for the exqMgtPrio column and set
         ret_len to its proper size in bytes. */
int           *
get_exqMgtPrio(void *data_context, size_t * ret_len)
{
    QOSEXTENDCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->nMgtPrio);
    return &datainfo->nMgtPrio;
}

/** XXX: Set the value of the exqMgtPrio column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_exqMgtPrio(void *data_context, int *val, size_t val_len)
{
    QOSEXTENDCFG_S *datainfo = data_context;
    datainfo->nMgtPrio = 0;
    memcpy(&datainfo->nMgtPrio, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the exqMgtId column and set
         ret_len to its proper size in bytes. */
int           *
get_exqMgtId(void *data_context, size_t * ret_len)
{
    QOSEXTENDCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->nMgtId);
    return &datainfo->nMgtId;
}

/** XXX: Set the value of the exqMgtId column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_exqMgtId(void *data_context, int *val, size_t val_len)
{
    QOSEXTENDCFG_S *datainfo = data_context;
    datainfo->nMgtId = 0;
    memcpy(&datainfo->nMgtId, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the exqMgtData column and set
         ret_len to its proper size in bytes. */
char           *
get_exqMgtData(void *data_context, size_t * ret_len)
{
    QOSEXTENDCFG_S   *datainfo = data_context;
	*ret_len = strlen(datainfo->cMgtData);
    return (char *)&datainfo->cMgtData;
}

/** XXX: Set the value of the exqMgtData column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_exqMgtData(void *data_context, char *val, size_t val_len)
{
    QOSEXTENDCFG_S *datainfo = data_context;
    memset(&datainfo->cMgtData, 0x00, sizeof(datainfo->cMgtData));
    memcpy(&datainfo->cMgtData, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the exqVoipPrio column and set
         ret_len to its proper size in bytes. */
int           *
get_exqVoipPrio(void *data_context, size_t * ret_len)
{
    QOSEXTENDCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->nVoipPrio);
    return &datainfo->nVoipPrio;
}

/** XXX: Set the value of the exqVoipPrio column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_exqVoipPrio(void *data_context, int *val, size_t val_len)
{
    QOSEXTENDCFG_S *datainfo = data_context;
    datainfo->nVoipPrio = 0;
    memcpy(&datainfo->nVoipPrio, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the exqVoipId column and set
         ret_len to its proper size in bytes. */
int           *
get_exqVoipId(void *data_context, size_t * ret_len)
{
    QOSEXTENDCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->nVoipId);
    return &datainfo->nVoipId;
}

/** XXX: Set the value of the exqVoipId column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_exqVoipId(void *data_context, int *val, size_t val_len)
{
    QOSEXTENDCFG_S *datainfo = data_context;
    datainfo->nVoipId = 0;
    memcpy(&datainfo->nVoipId, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the exqVoipData column and set
         ret_len to its proper size in bytes. */
char           *
get_exqVoipData(void *data_context, size_t * ret_len)
{
    QOSEXTENDCFG_S   *datainfo = data_context;
	*ret_len = strlen(datainfo->cVoipData);
    return (char *)&datainfo->cVoipData;
}

/** XXX: Set the value of the exqVoipData column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_exqVoipData(void *data_context, char *val, size_t val_len)
{
    QOSEXTENDCFG_S *datainfo = data_context;
    memset(&datainfo->cVoipData, 0x00, sizeof(datainfo->cVoipData));
    memcpy(&datainfo->cVoipData, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the exqSignalPrio column and set
         ret_len to its proper size in bytes. */
int           *
get_exqSignalPrio(void *data_context, size_t * ret_len)
{
    QOSEXTENDCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->nSignalPrio);
    return &datainfo->nSignalPrio;
}

/** XXX: Set the value of the exqSignalPrio column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_exqSignalPrio(void *data_context, int *val, size_t val_len)
{
    QOSEXTENDCFG_S *datainfo = data_context;
    datainfo->nSignalPrio = 0;
    memcpy(&datainfo->nSignalPrio, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the exqSignalId column and set
         ret_len to its proper size in bytes. */
int           *
get_exqSignalId(void *data_context, size_t * ret_len)
{
    QOSEXTENDCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->nSignalId);
    return &datainfo->nSignalId;
}

/** XXX: Set the value of the exqSignalId column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_exqSignalId(void *data_context, int *val, size_t val_len)
{
    QOSEXTENDCFG_S *datainfo = data_context;
    datainfo->nSignalId = 0;
    memcpy(&datainfo->nSignalId, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the exqSignalData column and set
         ret_len to its proper size in bytes. */
char           *
get_exqSignalData(void *data_context, size_t * ret_len)
{
    QOSEXTENDCFG_S   *datainfo = data_context;
	*ret_len = strlen(datainfo->cSignalData);
    return (char *)&datainfo->cSignalData;
}

/** XXX: Set the value of the exqSignalData column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_exqSignalData(void *data_context, char *val, size_t val_len)
{
    QOSEXTENDCFG_S *datainfo = data_context;
    memset(&datainfo->cSignalData, 0x00, sizeof(datainfo->cSignalData));
    memcpy(&datainfo->cSignalData, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the exqOtherPrio column and set
         ret_len to its proper size in bytes. */
int           *
get_exqOtherPrio(void *data_context, size_t * ret_len)
{
    QOSEXTENDCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->nOtherPrio);
    return &datainfo->nOtherPrio;
}

/** XXX: Set the value of the exqOtherPrio column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_exqOtherPrio(void *data_context, int *val, size_t val_len)
{
    QOSEXTENDCFG_S *datainfo = data_context;
    datainfo->nOtherPrio = 0;
    memcpy(&datainfo->nOtherPrio, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the exqOtherId column and set
         ret_len to its proper size in bytes. */
int           *
get_exqOtherId(void *data_context, size_t * ret_len)
{
    QOSEXTENDCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->nOtherId);
    return &datainfo->nOtherId;
}

/** XXX: Set the value of the exqOtherId column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_exqOtherId(void *data_context, int *val, size_t val_len)
{
    QOSEXTENDCFG_S *datainfo = data_context;
    datainfo->nOtherId = 0;
    memcpy(&datainfo->nOtherId, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the exqOtherData column and set
         ret_len to its proper size in bytes. */
char           *
get_exqOtherData(void *data_context, size_t * ret_len)
{
    QOSEXTENDCFG_S   *datainfo = data_context;
	*ret_len = strlen(datainfo->cOtherData);
    return (char *)&datainfo->cOtherData;
}

/** XXX: Set the value of the exqOtherData column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_exqOtherData(void *data_context, char *val, size_t val_len)
{
    QOSEXTENDCFG_S *datainfo = data_context;
    memset(&datainfo->cOtherData, 0x00, sizeof(datainfo->cOtherData));
    memcpy(&datainfo->cOtherData, val, val_len);
    return SNMP_ERR_NOERROR;
}
