/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-QOS-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxExtendQosTable_checkfns.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.check_values.conf,v 1.6 2003/06/13 18:18:04 hardaker Exp $
 */

/********************************************************************
 *                       NOTE   NOTE   NOTE
 *   This file is auto-generated and SHOULD NOT BE EDITED by hand.
 *   Modify the ifxExtendQosTable_checkfns_local.[ch] files insead so that you
 *   can regenerate this one as mib2c improvements are made.
 ********************************************************************/

/*
 * standard headers 
 */
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <stdlib.h>
#include "ifxExtendQosTable_checkfns.h"

/** Decides if an incoming value for the exqMgtPrio mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_exqMgtPrio(int type, int *val, size_t val_len,
                 int *old_val, size_t old_val_len)
{
    int ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the exqMgtId mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_exqMgtId(int type, int *val, size_t val_len,
               int *old_val, size_t old_val_len)
{
    int ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    if (!(*val >= 0 && *val <= 4095) )
    {
        snmp_log(LOG_ERR, "exqMgtId: Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the exqMgtData mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_exqMgtData(int type, char *val, size_t val_len,
                 char *old_val, size_t old_val_len)
{
    int ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_OCTET_STR)
        return SNMP_ERR_WRONGTYPE;

    if (val_len > 2)
    {
        snmp_log(LOG_ERR, "exqMgtData: Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }

    if (!(atoi(val) >= 0 && atoi(val) <= 63) )
    {
        snmp_log(LOG_ERR, "exqMgtData: Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the exqVoipPrio mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_exqVoipPrio(int type, int *val, size_t val_len,
                  int *old_val, size_t old_val_len)
{
    int ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the exqVoipId mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_exqVoipId(int type, int *val, size_t val_len,
                int *old_val, size_t old_val_len)
{
    int ret;
    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;
    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    if (!(*val >= 0 &&*val <= 4095) )
    {
        snmp_log(LOG_ERR, "exqVoipId: Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the exqVoipData mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_exqVoipData(int type, char *val, size_t val_len,
                  char *old_val, size_t old_val_len)
{
    int ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_OCTET_STR)
        return SNMP_ERR_WRONGTYPE;

    if (val_len > 2)
    {
        snmp_log(LOG_ERR, "exqVoipData: Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }

    if (!(atoi(val) >= 0 && atoi(val) <= 63) )
    {
        snmp_log(LOG_ERR, "exqVoipData: Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the exqSignalPrio mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_exqSignalPrio(int type, int *val, size_t val_len,
                    int *old_val, size_t old_val_len)
{
    int ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the exqSignalId mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_exqSignalId(int type, int *val, size_t val_len,
                    int *old_val, size_t old_val_len)
{
    int ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    if (!(*val >= 0 && *val <= 4095) )
    {
        snmp_log(LOG_ERR, "exqSignalId: Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the exqSignalData mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_exqSignalData(int type, char *val, size_t val_len,
                  char *old_val, size_t old_val_len)
{
    int ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_OCTET_STR)
        return SNMP_ERR_WRONGTYPE;

    if (val_len > 2)
    {
        snmp_log(LOG_ERR, "exqSignalData: Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }

    if (!(atoi(val) >= 0 && atoi(val) <= 63) )
    {
        snmp_log(LOG_ERR, "exqSignalData: Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the exqOtherPrio mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_exqOtherPrio(int type, int *val, size_t val_len,
                    int *old_val, size_t old_val_len)
{
    int ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the exqOtherId mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_exqOtherId(int type, int *val, size_t val_len,
                    int *old_val, size_t old_val_len)
{
    int ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_INTEGER)
        return SNMP_ERR_WRONGTYPE;

    if (!(*val >= 0 && *val <= 4095) )
    {
        snmp_log(LOG_ERR, "exqOtherId: Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the exqOtherData mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_exqOtherData(int type, char *val, size_t val_len,
                  char *old_val, size_t old_val_len)
{
    int ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_OCTET_STR)
        return SNMP_ERR_WRONGTYPE;

    if (val_len > 2)
    {
        snmp_log(LOG_ERR, "exqSignalData: Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }

    if (!(atoi(val) >= 0 && atoi(val) <= 63) )
    {
        snmp_log(LOG_ERR, "exqSignalData: Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }

    return SNMP_ERR_NOERROR;
}
