/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-QOS-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxQosStaticMacTable_access.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "ifxQosStaticMacTable_access.h"

/*
 * ===========================================================================
 *                          GLOBAL DEFINITIONS
 * ===========================================================================
*/
static char                 cTag[MAX_TAG_LEN];
static char                 cRetVal[MAX_DATA_LEN];
static unsigned int         nEntryNum = 0;

/*
 * ===========================================================================
 *                          LOCAL FUNCTIONS
 * ===========================================================================
*/
void *
ifxGetQosStaticMacCount()
{
    /* printf("**** ifxGetQosStaticMacCount ****\n"); */
    memset (&cRetVal, 0x00, MAX_DATA_LEN);
    memset (&xMibMsg, 0x00, sizeof(IFX_MIB_MSG_S));

	if (ifx_GetCfgData(FILE_RC_CONF, "static_filter_table", "filter_count",
	                   cRetVal) != 1)
	{
        snmp_log(LOG_ERR, "ifxQosStaticMacTable: unable get filter_count\n");
	}
	nEntryNum = atoi(cRetVal);

    if (nEntryNum > 0)
    {
        xMibMsg.nType = IFX_MIB_QOS_STATICMAC;
        xMibMsg.nCount = nEntryNum;
        xMibMsg.nPSize = sizeof(QOSSTATICMACCFG_S *);
        xMibMsg.nSize = sizeof(QOSSTATICMACCFG_S);

        ifx_MIB_Dalloc();
	}
}

netsnmp_variable_list *
ifxQosStaticMacTable_set_indexes(QOSSTATICMACCFG_S *datainfo,
                                 netsnmp_variable_list *put_index_data)
{
    /* printf("**** ifxQosStaticMacTable_set_indexes ****\n"); */
    netsnmp_variable_list   *vptr;

    /* qosStaticIndex */
    vptr = put_index_data;
    snmp_set_var_value(vptr, (u_char *) &datainfo->index ,
                       sizeof(datainfo->index) );

    return put_index_data;
}

void  *
ifxQosStaticMacTable_get_data(void)
{
    int              i = 0;

    ifxGetQosStaticMacCount();

    /* printf("**** ifxQosStaticMacTable_get_data ****\n"); */

    for ( i = 0; i < nEntryNum; i++)
    {
	    pstQosStaticMacCfg[i]->index = i;

        memset (&cRetVal, 0x00, MAX_DATA_LEN);
        memset (&cTag, 0x00, MAX_TAG_LEN);
        sprintf (cTag, "filter_mac%d", i);

    	if (ifx_GetCfgData(FILE_RC_CONF, "static_filter_table", cTag,
    	                   cRetVal) != 1)
    	{
            DEBUGMSGTL(("snmpd", "unable get cMacAddress\n"));
    	}
        strcpy (pstQosStaticMacCfg[i]->cMacAddress, cRetVal);

        memset (&cRetVal, 0x00, MAX_DATA_LEN);
        memset (&cTag, 0x00, MAX_TAG_LEN);
        sprintf (cTag, "filter_port%d", i);
    
        if (ifx_GetCfgData(FILE_RC_CONF, "static_filter_table", cTag,
                           cRetVal) != 1)
        {
            DEBUGMSGTL(("snmpd", "unable get nPortType\n"));
        }
        pstQosStaticMacCfg[i]->nPortType = atoi(cRetVal);

        /* Get Critical Traffic */
        memset (&cRetVal, 0x00, MAX_DATA_LEN);
        memset (&cTag, 0x00, MAX_TAG_LEN);
        sprintf (cTag, "filter_crit%d", i);
    
        if (ifx_GetCfgData(FILE_RC_CONF, "static_filter_table", cTag,
                           cRetVal) != 1)
        {
            DEBUGMSGTL(("snmpd", "unable get nCriticalTraffic\n"));
        }
        pstQosStaticMacCfg[i]->nCriticalTraffic = atoi(cRetVal);
    }
}

/** returns the first data point within the ifxQosStaticMacTable table data.

    Set the my_loop_context variable to the first data point structure
    of your choice (from which you can find the next one).  This could
    be anything from the first node in a linked list, to an integer
    pointer containing the beginning of an array variable.

    Set the my_data_context variable to something to be returned to
    you later that will provide you with the data to return in a given
    row.  This could be the same pointer as what my_loop_context is
    set to, or something different.

    The put_index_data variable contains a list of snmp variable
    bindings, one for each index in your table.  Set the values of
    each appropriately according to the data matching the first row
    and return the put_index_data variable at the end of the function.
*/
netsnmp_variable_list *
ifxQosStaticMacTable_get_first_data_point(void **my_loop_context,
                                          void **my_data_context,
                                          netsnmp_variable_list *
                                          put_index_data,
                                          netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxQosStaticMacTable_get_first_data_point ****\n"); */
    int     *position;

    /* we could do this with a file-static variable, but for learning
       purposes we'll use memory allocation to demonstrate simplistic
       freeing of a loop_context */
    position = (int *)malloc(sizeof(int));
    if (!position)
        return NULL;

    ifxQosStaticMacTable_get_data();

    if (!pstQosStaticMacCfg)
    {
        snmp_log(LOG_ERR, "ifxQosStaticMacTable: None of row for this table.\n");
        free(position);
        return NULL;
    }

    /* We use the positinonal count as our loop context */
    *position = 0;
    *my_loop_context = position;

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = pstQosStaticMacCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxQosStaticMacTable_set_indexes(pstQosStaticMacCfg[*position],
                                            put_index_data);
}

/** functionally the same as ifxQosStaticMacTable_get_next_data_point, but
   my_loop_context has already been set to a previous value and should
   be updated to the next in the list.  For example, if it was a
   linked list, you might want to cast it to your local data type and
   then return my_loop_context->next.  The my_data_context pointer
   should be set to something you need later and the indexes in
   put_index_data updated again. */
netsnmp_variable_list *
ifxQosStaticMacTable_get_next_data_point(void **my_loop_context,
                                         void **my_data_context,
                                         netsnmp_variable_list *
                                         put_index_data,
                                         netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxQosStaticMacTable_get_next_data_point ****\n"); */
    int *position = (int *) *my_loop_context;

    /* make sure we were called correctly */
    if (!position)
        return NULL;
    
    /* go to the next entry in the list */
    (*position)++;

    /* Are we beyond the end? */
    if (*position >= nEntryNum)
    {
        /* End of entry.  stop here by returning NULL */
        free(position);
        ifxGetQosStaticMacCount();
        *my_loop_context = NULL;
        *my_data_context = NULL;
        return NULL;
    }

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = pstQosStaticMacCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxQosStaticMacTable_set_indexes(pstQosStaticMacCfg[*position],
                                            put_index_data);
}

/** Create a data_context for non-existent rows that SETs are performed on.
 *  return a void * pointer which will be passed to subsequent get_XXX
 *  and set_XXX functions for data retrival and modification during
 *  this SET request.
 *
 *  The indexs are encoded (in order) into the index_data pointer if it
 *  would be helpful to use that information.
 */
void           *
ifxQosStaticMacTable_create_data_context(netsnmp_variable_list * index_data,
                                         int column)
{
#ifdef IFX_ADD_ROW
    /* currently, does not support to add/create row dynamicly. */
    pstQosStaticMacCfg[nEntryNum] =
        (QOSSTATICMACCFG_S *) malloc(sizeof(QOSSTATICMACCFG_S));

    if (!pstQosStaticMacCfg[nEntryNum])
        return NULL;

    memset (pstQosStaticMacCfg[nEntryNum], 0x00, sizeof(QOSSTATICMACCFG_S));
    pstQosStaticMacCfg[nEntryNum]->index = (int) index_data->val.string;

    return pstQosStaticMacCfg[nEntryNum];
#else
    return NULL;
#endif
}

/** If the implemented set_* functions don't operate directly on the
   real-live data (which is actually recommended), then this function
   can be used to take a given my_data_context pointer and "commit" it
   to whereever the modified data needs to be put back to.  For
   example, if this was a routing table you could publish the modified
   routes back into the kernel at this point.

   new_or_del will be set to 1 if new, or -1 if it should be deleted
   or 0 if it is just a modification of an existing row.

   If you free the data yourself, make sure to *my_data_context = NULL */
int
ifxQosStaticMacTable_commit_row(void **my_data_context, int new_or_del)
{
    QOSSTATICMACCFG_S       *datactx = *my_data_context;
    char                    sBuf[BUF_SIZE_1K];
    char                    sMacAddress[MAX_DATA_LEN];
    char                    sPortType[MAX_DATA_LEN];
    char                    sCriticalTraffic[MAX_DATA_LEN];
    char                    sCommand[MAX_DATA_LEN];
    int                     nSetReturn = -1;
    int                     i = 0;

    /* printf("**** ifxQosStaticMacTable_commit_row ****\n"); */

    if (new_or_del == -1)
    {
        return SNMP_ERR_NOERROR; /* no change in the value */
    }

    ifxGetQosStaticMacCount();

    memset (&sBuf, 0x00, BUF_SIZE_1K);

    for (i = 0; i < nEntryNum; i++)
    {
        memset (&sMacAddress, 0x00, MAX_DATA_LEN);
        memset (&sPortType, 0x00, MAX_DATA_LEN);
        memset (&sCriticalTraffic, 0x00, MAX_DATA_LEN);

        if (i == datactx->index)
        {
            sprintf (sMacAddress, "filter_mac%d=\"%s\"\n",
                     i, datactx->cMacAddress);
            strcat (sBuf, sMacAddress);
            sprintf (sPortType, "filter_port%d=\"%d\"\n",
                     i, datactx->nPortType);
            strcat (sBuf, sPortType);
            sprintf (sCriticalTraffic, "filter_crit%d=\"%d\"\n",
                     i, datactx->nCriticalTraffic);
            strcat (sBuf, sCriticalTraffic);
        }
        else
        {
            memset (&cRetVal, 0x00, MAX_DATA_LEN);
            memset (&cTag, 0x00, MAX_TAG_LEN);
            sprintf (cTag, "filter_mac%d", i);
        	ifx_GetCfgData(FILE_RC_CONF, "static_filter_table", cTag, cRetVal);
            sprintf (sMacAddress, "%s=\"%s\"\n", cTag, cRetVal);
            strcat (sBuf, sMacAddress);

        	memset (&cRetVal, 0x00, MAX_DATA_LEN);
            memset (&cTag, 0x00, MAX_TAG_LEN);
            sprintf (cTag, "filter_port%d", i);
        	ifx_GetCfgData(FILE_RC_CONF, "static_filter_table", cTag, cRetVal);
            sprintf (sPortType, "%s=\"%s\"\n", cTag, cRetVal);
            strcat (sBuf, sPortType);
    
            memset (&cRetVal, 0x00, MAX_DATA_LEN);
            memset (&cTag, 0x00, MAX_TAG_LEN);
            sprintf (cTag, "filter_crit%d", i);
        	ifx_GetCfgData(FILE_RC_CONF, "static_filter_table", cTag, cRetVal);
            sprintf (sCriticalTraffic, "%s=\"%s\"\n", cTag, cRetVal);
            strcat (sBuf, sCriticalTraffic);
        }
    }

#ifdef IFX_ADD_ROW
    /* currently, does not support to add/create row dynamicly. */
    if (new_or_del == 1)
    {
        memset (&sMacAddress, 0x00, MAX_DATA_LEN);
        memset (&sPortType, 0x00, MAX_DATA_LEN);
        memset (&sCriticalTraffic, 0x00, MAX_DATA_LEN);

        nEntryNum++;
        sprintf (sMacAddress, "filter_mac%d=\"%s\"\n",
                 nEntryNum-1, datactx->cMacAddress);
        strcat (sBuf, sMacAddress);
        sprintf (sPortType, "filter_port%d=\"%d\"\n",
                 nEntryNum-1, datactx->nPortType);
        strcat (sBuf, sPortType);
        sprintf (sCriticalTraffic, "filter_crit%d=\"%d\"\n",
                 nEntryNum-1, datactx->nCriticalTraffic);
        strcat (sBuf, sCriticalTraffic);
    }
#endif

    sprintf (sCommand, "filter_count=\"%d\"\n", nEntryNum);
    strcat (sBuf, sCommand);

    nSetReturn = websSetCfgData(FILE_RC_CONF, "static_filter_table", 1, sBuf);

    if (nSetReturn != 1)
    {
        return SNMP_ERR_COMMITFAILED;
    }

#ifdef IFX_ADD_ROW
    /* currently, does not support to add/create row dynamicly. */
    if (new_or_del == 1)
    {
        if (pstQosStaticMacCfg[nEntryNum-1])
        {
            free(pstQosStaticMacCfg[nEntryNum-1]);
            pstQosStaticMacCfg[nEntryNum-1] = NULL;
        }
    }
#endif

    /*
     * return no errors.  And there shouldn't be any!!!  Ever!!!  You
     * should have checked the values long before this. 
     */
    return SNMP_ERR_NOERROR;
}

/*
 * User-defined data access functions (per column) for data in table ifxQosStaticMacTable 
 */
/*
 * NOTE:
 * - these get_ routines MUST return data that will not be freed (ie,
 *   use static variables or persistent data).  It will be copied, if
 *   needed, immediately after the get_ routine has been called.
 * - these SET routines must copy the incoming data and can not take
 *   ownership of the memory passed in by the val pointer.
 */
/** XXX: return a data pointer to the data for the qosMACAddress column and set
         ret_len to its proper size in bytes. */
char           *
get_qosMACAddress(void *data_context, size_t * ret_len)
{
    QOSSTATICMACCFG_S   *datainfo = (QOSSTATICMACCFG_S *)data_context;
	*ret_len = strlen(datainfo->cMacAddress);
    return (char *) &datainfo->cMacAddress;
}

/** XXX: Set the value of the qosMACAddress column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_qosMACAddress(void *data_context, char *val, size_t val_len)
{
    QOSSTATICMACCFG_S *datainfo = data_context;
    memset(&datainfo->cMacAddress, 0x00, sizeof(datainfo->cMacAddress));
    memcpy(&datainfo->cMacAddress, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the qosPortType column and set
         ret_len to its proper size in bytes. */
int           *
get_qosPortType(void *data_context, size_t * ret_len)
{
    QOSSTATICMACCFG_S   *datainfo = (QOSSTATICMACCFG_S *)data_context;
	*ret_len = sizeof(datainfo->nPortType);
    return &datainfo->nPortType;
}

/** XXX: Set the value of the qosPortType column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_qosPortType(void *data_context, int *val, size_t val_len)
{
    QOSSTATICMACCFG_S *datainfo = data_context;
    datainfo->nPortType = 0;
    memcpy(&datainfo->nPortType, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the qosCriticalTraffic column and set
         ret_len to its proper size in bytes. */
int           *
get_qosCriticalTraffic(void *data_context, size_t * ret_len)
{
    QOSSTATICMACCFG_S   *datainfo = (QOSSTATICMACCFG_S *)data_context;
	*ret_len = sizeof(datainfo->nCriticalTraffic);
    return &datainfo->nCriticalTraffic;
}

/** XXX: Set the value of the qosCriticalTraffic column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_qosCriticalTraffic(void *data_context, int *val, size_t val_len)
{
    QOSSTATICMACCFG_S *datainfo = data_context;
    datainfo->nCriticalTraffic = 0;
    memcpy(&datainfo->nCriticalTraffic, val, val_len);
    return SNMP_ERR_NOERROR;
}
