/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-VOIP-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxCallFwTable.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.iterate_access.conf,v 1.11 2004/08/31 10:23:16 dts12 Exp $
 */
/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
*/
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "ifxCallFwTable.h"

/*
 * ===========================================================================
 *                          GLOBAL DEFINITIONS
 * ===========================================================================
*/
static netsnmp_oid_stash_node *undoStorage = NULL;
static netsnmp_oid_stash_node *commitStorage = NULL;

struct undoInfo {
    void           *ptr;
    size_t          len;
};

struct commitInfo {
    void           *data_context;
    int             have_committed;
    int             new_row;
};

/*
 * ===========================================================================
 *                           GLOBAL FUNCTIONS
 * ===========================================================================
*/
void
ifxCallFwTable_free_undoInfo(void *vptr)
{
    struct undoInfo *ui = vptr;
    if (!ui)
        return;
    SNMP_FREE(ui->ptr);
    SNMP_FREE(ui);
}

/** Initialize the ifxCallFwTable table by defining its contents and how it's structured */
void
initialize_table_ifxCallFwTable(void)
{
    static oid      ifxCallFwTable_oid[] =
        { 1, 3, 6, 1, 4, 1, IFX_MIB, IFX_PRODUCT, 2, 8 };
    netsnmp_table_registration_info *table_info;
    netsnmp_handler_registration *my_handler;
    netsnmp_iterator_info *iinfo;

    /** create the table registration information structures */
    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    iinfo = SNMP_MALLOC_TYPEDEF(netsnmp_iterator_info);

    my_handler = netsnmp_create_handler_registration("ifxCallFwTable",
                                                     ifxCallFwTable_handler,
                                                     ifxCallFwTable_oid,
                                                     OID_LENGTH
                                                     (ifxCallFwTable_oid),
                                                     HANDLER_CAN_RWRITE);

    if (!my_handler || !table_info || !iinfo) {

#ifdef IIP_MEM_LEAK_FIX
         if (my_handler)
            SNMP_FREE(my_handler);
         if (table_info)
            SNMP_FREE(table_info);
          if (iinfo)
            SNMP_FREE(iinfo);
#endif
        snmp_log(LOG_ERR,\
                 "malloc failed in initialize_table_ifxCallFwTable");
        return; /** Serious error. */
    }

    /***************************************************
     * Setting up the table's definition
     */
    netsnmp_table_helper_add_indexes(table_info, ASN_UNSIGNED,
                                               /** index: endPointIndex */
                                     ASN_OCTET_STR,
                                                 /** index: suUserName */
                                     ASN_OCTET_STR,
                                                 /** index: suDomainName */
                                     ASN_UNSIGNED,
                                                 /** index: cfType */
                                     0);

    /** Define the minimum and maximum accessible columns.  This
        optimizes retrival. */
    table_info->min_column = COLUMN_CFADDRESSTYPE;
    table_info->max_column = COLUMN_CFROWSTATUS;

    /** iterator access routines */
    iinfo->get_first_data_point = ifxCallFwTable_get_first_data_point;
    iinfo->get_next_data_point = ifxCallFwTable_get_next_data_point;

    /** you may wish to set these as well */
#ifdef MAYBE_USE_THESE
    iinfo->make_data_context = ifxCallFwTable_context_convert_function;
    iinfo->free_data_context = ifxCallFwTable_data_free;

    /** pick *only* one of these if you use them */
    iinfo->free_loop_context = ifxCallFwTable_loop_free;
    iinfo->free_loop_context_at_end = ifxCallFwTable_loop_free;
#endif

    /** tie the two structures together */
    iinfo->table_reginfo = table_info;

    /***************************************************
     * registering the table with the master agent
     */
    DEBUGMSGTL(("initialize_table_ifxCallFwTable",
                "Registering table ifxCallFwTable as a table iterator\n"));
    netsnmp_register_table_iterator(my_handler, iinfo);
}

/** Initializes the ifxCallFwTable module */
void
init_ifxCallFwTable(void)
{
    /** here we initialize all the tables we're planning on supporting */
    initialize_table_ifxCallFwTable();
}

/** handles requests for the ifxCallFwTable table, if anything else needs to be done */
int
ifxCallFwTable_handler(netsnmp_mib_handler *handler,
                       netsnmp_handler_registration *reginfo,
                       netsnmp_agent_request_info *reqinfo,
                       netsnmp_request_info *requests)
{
    netsnmp_request_info        *request;
    netsnmp_table_request_info  *table_info;
    netsnmp_variable_list       *var;
    struct commitInfo           *ci = NULL;
    void                        *data_context = NULL;
    oid                         *suffix;
    size_t                      suffix_len;

    for (request = requests; request != NULL; request = request->next)
    {
        /** column and row index encoded portion */
        var = request->requestvb;
        suffix = var->name + reginfo->rootoid_len + 1;
        suffix_len = var->name_length - (reginfo->rootoid_len + 1);
        if (request->processed != 0)
            continue;

        switch (reqinfo->mode)
        {
        case MODE_GET:
            data_context = netsnmp_extract_iterator_context(request);
            if (data_context == NULL)
            {
                if (reqinfo->mode == MODE_GET)
                {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
            }
            break;

        case MODE_SET_RESERVE1:
            data_context = netsnmp_extract_iterator_context(request);
            if (data_context == NULL)
            {
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_ERR_NOCREATION);
                continue;
            }
            break;

        default:               /* == the other SET modes */
            ci = netsnmp_oid_stash_get_data(commitStorage,
                                            suffix + 1, suffix_len - 1);
            break;

        }

        /** extracts the information about the table from the request */
        table_info = netsnmp_extract_table_info(request);
        /** table_info->colnum contains the column number requested */
        /** table_info->indexes contains a linked list of snmp variable
           bindings for the indexes of the table.  Values in the list
           have been set corresponding to the indexes of the
           request */
        if (table_info == NULL)
        {
            continue;
        }

        switch (reqinfo->mode)
        {
        case MODE_GET:
            switch (table_info->colnum)
            {
            case COLUMN_CFTYPE:
                {
                    u_long         *retval;
                    size_t          retval_len = 0;
                    retval = get_cfType(data_context, &retval_len);
                    if (retval)
                        snmp_set_var_typed_value(var, ASN_UNSIGNED,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_CFADDRESSTYPE:
                {
                    u_long         *retval;
                    size_t          retval_len = 0;
                    retval = get_cfAddressType(data_context, &retval_len);
                    if (retval)
                        snmp_set_var_typed_value(var, ASN_UNSIGNED,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_CFDISPLAYNAME:
                {
                    char           *retval;
                    size_t          retval_len = 0;
                    retval = get_cfDisplayName(data_context, &retval_len);
                    if (retval)
                    snmp_set_var_typed_value(var, ASN_OCTET_STR,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_CFUSERNAME:
                {
                    char           *retval;
                    size_t          retval_len = 0;
                    retval = get_cfUserName(data_context, &retval_len);
                    if (retval)
                    snmp_set_var_typed_value(var, ASN_OCTET_STR,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_CFADDRESS:
                {
                    char           *retval;
                    size_t          retval_len = 0;
                    retval = get_cfAddress(data_context, &retval_len);
                    if (retval)
                    snmp_set_var_typed_value(var, ASN_OCTET_STR,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_CFPORT:
                {
                    u_long         *retval;
                    size_t          retval_len = 0;
                    retval = get_cfPort(data_context, &retval_len);
                    if (retval)
                    snmp_set_var_typed_value(var, ASN_UNSIGNED,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_CFPROTOCOL:
                {
                    u_long         *retval;
                    size_t          retval_len = 0;
                    retval = get_cfProtocol(data_context, &retval_len);
                    if (retval)
                        snmp_set_var_typed_value(var, ASN_UNSIGNED,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            case COLUMN_CFROWSTATUS:
                {
                    long           *retval;
                    size_t          retval_len = 0;
                    retval = get_cfRowStatus(data_context, &retval_len);
                    if (retval)
                    snmp_set_var_typed_value(var, ASN_INTEGER,
                                             (const u_char *) retval,
                                             retval_len);
                }
                break;

            default:
                /** We shouldn't get here */
                snmp_log(LOG_ERR,
                         "problem encountered in ifxCallFwTable_handler: unknown column\n");
            }
            break;

        case MODE_SET_RESERVE1:
            ci = netsnmp_oid_stash_get_data(commitStorage,
                                            suffix + 1, suffix_len - 1);

            if (!ci) {
                    /** create the commit storage info */
                ci = SNMP_MALLOC_STRUCT(commitInfo);
                if (!data_context) {
                    ci->data_context =
                        ifxCallFwTable_create_data_context(table_info->indexes,
                                                           table_info->colnum);
                    ci->new_row = 1;
                } else {
                    ci->data_context = data_context;
                }
                netsnmp_oid_stash_add_data(&commitStorage,
                                           suffix + 1, suffix_len - 1, ci);
            }
            break;

        case MODE_SET_RESERVE2:
            switch (table_info->colnum) {
            case COLUMN_CFADDRESSTYPE:
                {
                    u_long         *retval;
                    size_t          retval_len = 0;
                    struct undoInfo *ui = NULL;
                    int             ret;

                    /** first, get the old value */
                    retval =
                        get_cfAddressType(ci->data_context, &retval_len);
                    if (retval) {
                        ui = SNMP_MALLOC_STRUCT(undoInfo);
                        ui->len = retval_len;
                        memdup((u_char **) & ui->ptr,
                               (u_char *) retval, ui->len);
                    }

                    /** check the new value, possibly against the
                        older value for a valid state transition */
                    ret = check_cfAddressType(var->type,
                                              (u_long *) var->
                                              val.string,
                                              var->val_len,
                                              retval, retval_len);
                    if (ret != 0) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                        ifxCallFwTable_free_undoInfo(ui);
                    } else if (ui) {
                        /** remember information for undo purposes later */
                        netsnmp_oid_stash_add_data(&undoStorage,
                                                   suffix, suffix_len, ui);
                    }

                }
                break;
            case COLUMN_CFDISPLAYNAME:
                {
                    char           *retval;
                    size_t          retval_len = 0;
                    struct undoInfo *ui = NULL;
                    int             ret;

                    /** first, get the old value */
                    retval =
                        get_cfDisplayName(ci->data_context, &retval_len);
                    if (retval) {
                        ui = SNMP_MALLOC_STRUCT(undoInfo);
                        ui->len = retval_len;
                        memdup((u_char **) & ui->ptr,
                               (u_char *) retval, ui->len);
                    }

                    /** check the new value, possibly against the
                        older value for a valid state transition */
                    ret = check_cfDisplayName(var->type,
                                              (char *) var->
                                              val.string,
                                              var->val_len,
                                              retval, retval_len);
                    if (ret != 0) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                        ifxCallFwTable_free_undoInfo(ui);
                    } else if (ui) {
                        /** remember information for undo purposes later */
                        netsnmp_oid_stash_add_data(&undoStorage,
                                                   suffix, suffix_len, ui);
                    }

                }
                break;
            case COLUMN_CFUSERNAME:
                {
                    char           *retval;
                    size_t          retval_len = 0;
                    struct undoInfo *ui = NULL;
                    int             ret;

                    /** first, get the old value */
                    retval = get_cfUserName(ci->data_context, &retval_len);
                    if (retval) {
                        ui = SNMP_MALLOC_STRUCT(undoInfo);
                        ui->len = retval_len;
                        memdup((u_char **) & ui->ptr,
                               (u_char *) retval, ui->len);
                    }

                    /** check the new value, possibly against the
                        older value for a valid state transition */
                    ret = check_cfUserName(var->type,
                                           (char *) var->
                                           val.string,
                                           var->val_len,
                                           retval, retval_len);
                    if (ret != 0) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                        ifxCallFwTable_free_undoInfo(ui);
                    } else if (ui) {
                        /** remember information for undo purposes later */
                        netsnmp_oid_stash_add_data(&undoStorage,
                                                   suffix, suffix_len, ui);
                    }

                }
                break;
            case COLUMN_CFADDRESS:
                {
                    char           *retval;
                    size_t          retval_len = 0;
                    struct undoInfo *ui = NULL;
                    int             ret;
                    VOIPCALLFWCFG_S *xTemp;

                    /** first, get the old value */
                    retval = get_cfAddress(ci->data_context, &retval_len);
                    if (retval) {
                        ui = SNMP_MALLOC_STRUCT(undoInfo);
                        ui->len = retval_len;
                        memdup((u_char **) & ui->ptr,
                               (u_char *) retval, ui->len);
                    }

                    xTemp = (VOIPCALLFWCFG_S *) ci->data_context;
                    if (xTemp->ulAddrType == IFX_CM_IP_ADDR &&
                        xTemp->lRowStatus == ROWSTATUS_ACTIVE)
                    {
                        /** check the new value, possibly against the
                            older value for a valid state transition */
                        ret = check_cfAddress(var->type,
                                              (char *) var->val.
                                              string,
                                              var->val_len,
                                              retval, retval_len);
                    }
                    else
                    {
                        ret = SNMP_ERR_NOERROR;
                    }

                    if (ret != 0) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                        ifxCallFwTable_free_undoInfo(ui);
                    } else if (ui) {
                        /** remember information for undo purposes later */
                        netsnmp_oid_stash_add_data(&undoStorage,
                                                   suffix, suffix_len, ui);
                    }

                }
                break;
            case COLUMN_CFPORT:
                {
                    u_long         *retval;
                    size_t          retval_len = 0;
                    struct undoInfo *ui = NULL;
                    int             ret;

                    /** first, get the old value */
                    retval = get_cfPort(ci->data_context, &retval_len);
                    if (retval) {
                        ui = SNMP_MALLOC_STRUCT(undoInfo);
                        ui->len = retval_len;
                        memdup((u_char **) & ui->ptr,
                               (u_char *) retval, ui->len);
                    }

                    /** check the new value, possibly against the
                        older value for a valid state transition */
                    ret = check_cfPort(var->type,
                                       (u_long *) var->val.
                                       string, var->val_len,
                                       retval, retval_len);
                    if (ret != 0) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                        ifxCallFwTable_free_undoInfo(ui);
                    } else if (ui) {
                        /** remember information for undo purposes later */
                        netsnmp_oid_stash_add_data(&undoStorage,
                                                   suffix, suffix_len, ui);
                    }

                }
                break;
            case COLUMN_CFPROTOCOL:
                {
                    u_long           *retval;
                    size_t          retval_len = 0;
                    struct undoInfo *ui = NULL;
                    int             ret;

                    /** first, get the old value */
                    retval = get_cfProtocol(ci->data_context, &retval_len);
                    if (retval) {
                        ui = SNMP_MALLOC_STRUCT(undoInfo);
                        ui->len = retval_len;
                        memdup((u_char **) & ui->ptr,
                               (u_char *) retval, ui->len);
                    }

                    /** check the new value, possibly against the
                        older value for a valid state transition */
                    ret = check_cfProtocol(var->type,
                                           (u_long *) var->
                                           val.string,
                                           var->val_len,
                                           retval, retval_len);
                    if (ret != 0) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                        ifxCallFwTable_free_undoInfo(ui);
                    } else if (ui) {
                        /** remember information for undo purposes later */
                        netsnmp_oid_stash_add_data(&undoStorage,
                                                   suffix, suffix_len, ui);
                    }

                }
                break;
            case COLUMN_CFROWSTATUS:
                {
                    long           *retval;
                    size_t          retval_len = 0;
                    struct undoInfo *ui = NULL;
                    int             ret;

                    /** first, get the old value */
                    retval =
                        get_cfRowStatus(ci->data_context, &retval_len);
                    if (retval) {
                        ui = SNMP_MALLOC_STRUCT(undoInfo);
                        ui->len = retval_len;
                        memdup((u_char **) & ui->ptr,
                               (u_char *) retval, ui->len);
                    }

                    /** check the new value, possibly against the
                        older value for a valid state transition */
                    ret = check_cfRowStatus(var->type,
                                            (long *) var->
                                            val.string,
                                            var->val_len,
                                            retval, retval_len);
                    if (ret != 0) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                        ifxCallFwTable_free_undoInfo(ui);
                    } else if (ui) {
                        /** remember information for undo purposes later */
                        netsnmp_oid_stash_add_data(&undoStorage,
                                                   suffix, suffix_len, ui);
                    }

                }
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_ERR_NOTWRITABLE);
                break;
            }
            break;

        case MODE_SET_ACTION:
            /** save a variable copy */
            switch (table_info->colnum) {
            case COLUMN_CFADDRESSTYPE:
                {
                    int             ret;
                    ret = set_cfAddressType(ci->data_context,
                                            (u_long *) var->
                                            val.string,
                                            var->val_len);
                    if (ret) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                    }
                }
                break;
            case COLUMN_CFDISPLAYNAME:
                {
                    int             ret;
                    ret = set_cfDisplayName(ci->data_context,
                                            (char *) var->
                                            val.string,
                                            var->val_len);
                    if (ret) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                    }
                }
                break;
            case COLUMN_CFUSERNAME:
                {
                    int             ret;
                    ret = set_cfUserName(ci->data_context,
                                         (char *) var->val.
                                         string,
                                         var->val_len);
                    if (ret) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                    }
                }
                break;
            case COLUMN_CFADDRESS:
                {
                    int             ret;
                    ret = set_cfAddress(ci->data_context,
                                        (char *) var->val.
                                        string,
                                        var->val_len);
                    if (ret) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                    }
                }
                break;
            case COLUMN_CFPORT:
                {
                    int             ret;
                    ret = set_cfPort(ci->data_context,
                                     (u_long *) var->val.
                                     string, var->val_len);
                    if (ret) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                    }
                }
                break;
            case COLUMN_CFPROTOCOL:
                {
                    int             ret;
                    ret = set_cfProtocol(ci->data_context,
                                         (u_long *) var->val.
                                         string,
                                         var->val_len);
                    if (ret) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                    }
                }
                break;
            case COLUMN_CFROWSTATUS:
                {
                    int             ret;
                    ret = set_cfRowStatus(ci->data_context,
                                          (long *) var->val.
                                          string,
                                          var->val_len);
                    if (ret) {
                        netsnmp_set_request_error(reqinfo, request, ret);
                    }
                    if (*var->val.integer == RS_DESTROY) {
                        ci->new_row = -1;
                    }
                }
                break;
            }
            break;

        case MODE_SET_COMMIT:
            if (!ci->have_committed) {
                    /** do this once per row only */
                ifxCallFwTable_commit_row(&ci->data_context, ci->new_row);
                ci->have_committed = 1;
            }
            break;

        case MODE_SET_UNDO:
             /** save a variable copy */
            switch (table_info->colnum) {
            case COLUMN_CFADDRESSTYPE:
                {
                    int             retval;
                    struct undoInfo *ui;
                    ui = netsnmp_oid_stash_get_data(undoStorage,
                                                    suffix, suffix_len);
                    retval = set_cfAddressType(ci->data_context, ui->ptr,
                                               ui->len);
                    if (retval) {
                        netsnmp_set_request_error(reqinfo, request,
                                                  SNMP_ERR_UNDOFAILED);
                    }
                }
                break;
            case COLUMN_CFDISPLAYNAME:
                {
                    int             retval;
                    struct undoInfo *ui;
                    ui = netsnmp_oid_stash_get_data(undoStorage,
                                                    suffix, suffix_len);
                    retval = set_cfDisplayName(ci->data_context, ui->ptr,
                                               ui->len);
                    if (retval) {
                        netsnmp_set_request_error(reqinfo, request,
                                                  SNMP_ERR_UNDOFAILED);
                    }
                }
                break;
            case COLUMN_CFUSERNAME:
                {
                    int             retval;
                    struct undoInfo *ui;
                    ui = netsnmp_oid_stash_get_data(undoStorage,
                                                    suffix, suffix_len);
                    retval = set_cfUserName(ci->data_context, ui->ptr,
                                            ui->len);
                    if (retval) {
                        netsnmp_set_request_error(reqinfo, request,
                                                  SNMP_ERR_UNDOFAILED);
                    }
                }
                break;
            case COLUMN_CFADDRESS:
                {
                    int             retval;
                    struct undoInfo *ui;
                    ui = netsnmp_oid_stash_get_data(undoStorage,
                                                    suffix, suffix_len);
                    retval = set_cfAddress(ci->data_context, ui->ptr,
                                           ui->len);
                    if (retval) {
                        netsnmp_set_request_error(reqinfo, request,
                                                  SNMP_ERR_UNDOFAILED);
                    }
                }
                break;
            case COLUMN_CFPORT:
                {
                    int             retval;
                    struct undoInfo *ui;
                    ui = netsnmp_oid_stash_get_data(undoStorage,
                                                    suffix, suffix_len);
                    retval = set_cfPort(ci->data_context, ui->ptr,
                                        ui->len);
                    if (retval) {
                        netsnmp_set_request_error(reqinfo, request,
                                                  SNMP_ERR_UNDOFAILED);
                    }
                }
                break;
            case COLUMN_CFPROTOCOL:
                {
                    int             retval;
                    struct undoInfo *ui;
                    ui = netsnmp_oid_stash_get_data(undoStorage,
                                                    suffix, suffix_len);
                    retval = set_cfProtocol(ci->data_context, ui->ptr,
                                            ui->len);
                    if (retval) {
                        netsnmp_set_request_error(reqinfo, request,
                                                  SNMP_ERR_UNDOFAILED);
                    }
                }
                break;
            case COLUMN_CFROWSTATUS:
                {
                    int             retval;
                    struct undoInfo *ui;
                    ui = netsnmp_oid_stash_get_data(undoStorage,
                                                    suffix, suffix_len);
                    retval = set_cfRowStatus(ci->data_context, ui->ptr,
                                             ui->len);
                    if (retval) {
                        netsnmp_set_request_error(reqinfo, request,
                                                  SNMP_ERR_UNDOFAILED);
                    }
                }
                break;
            }
            break;

        case MODE_SET_FREE:
            break;

        default:
            snmp_log(LOG_ERR,
                     "problem encountered in ifxCallFwTable_handler: unsupported mode\n");
        }
    }

    /** clean up after all requset processing has ended */
    switch (reqinfo->mode) {
    case MODE_SET_UNDO:
    case MODE_SET_FREE:
    case MODE_SET_COMMIT:
        /** clear out the undo cache */
        netsnmp_oid_stash_free(&undoStorage, ifxCallFwTable_free_undoInfo);
        netsnmp_oid_stash_free(&commitStorage, netsnmp_oid_stash_no_free);
    }

    return SNMP_ERR_NOERROR;
}
