/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-VOIP-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxCodecTable_access.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.9 2004/10/14 12:57:33 dts12 Exp $
*/
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "ifxCodecTable_access.h"

/*
 * ===========================================================================
 *                          GLOBAL DEFINITIONS
 * ===========================================================================
*/
static x_IFX_CM_Msg         xCmMsg;
static unsigned int         nEntryNum = 0;

void *
ifxGetCodecListCount()
{
    /* printf("**** ifxGetCodecListCount ****\n"); */
    memset (&xCmMsg, 0x00, sizeof(x_IFX_CM_Msg));
    memset (&xMibMsg, 0x00, sizeof(IFX_MIB_MSG_S));

   	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
	xCmMsg.ucInfoType = IFX_CM_MEDIA_CONFIG;
	xCmMsg.ucChannel = 0;

    if (IFX_CM_RecvDataFromCM (&xCmMsg) != IFX_CM_SUCCESS)
    {
        snmp_log(LOG_ERR,"ifxCodecTable: Fail to receive data from CM\n");
    }

	nEntryNum = xCmMsg.uxData.xMediaCfg.xCodecList.unNoOfCodecs;

    if (nEntryNum > 0)
    {
        xMibMsg.nType = IFX_MIB_VOIP_CODEC;
        xMibMsg.nCount = nEntryNum;
        xMibMsg.nPSize = sizeof(VOIPCODECCFG_S *);
        xMibMsg.nSize = sizeof(VOIPCODECCFG_S);

        ifx_MIB_Dalloc();
	}
}

netsnmp_variable_list *
ifxCodecTable_set_indexes(VOIPCODECCFG_S *datainfo,
                          netsnmp_variable_list *put_index_data)
{
    /* printf("**** ifxCodecTable_set_indexes ****\n"); */
    netsnmp_variable_list   *vptr;

    /* endPointIdx */
    vptr = put_index_data;
    snmp_set_var_value(vptr, (u_char *) &datainfo->ulEndPointIdx,
                       sizeof(datainfo->ulEndPointIdx) );

    /* suUserName */
    vptr = vptr->next_variable;
    snmp_set_var_value(vptr, (u_char *) &datainfo->cUserName,
                       strlen(datainfo->cUserName) );

    /* suDomainName */
    vptr = vptr->next_variable;
    snmp_set_var_value(vptr, (u_char *) &datainfo->cDomainName,
                       strlen(datainfo->cDomainName) );

    /* codecIndex */
    vptr = vptr->next_variable;
    snmp_set_var_value(vptr, (u_char *) &datainfo->ulIndex ,
                       sizeof(datainfo->ulIndex) );

    return put_index_data;
}

VOIPCODECCFG_S  **
ifxCodecTable_get_data(void)
{
    int              i = 0;
    char             sCommand[MAX_DATA_LEN];

    ifxGetCodecListCount();

    for ( i = 0; i < nEntryNum; i++)
    {
        memset (&xCmMsg, 0x00, sizeof(x_IFX_CM_Msg));

       	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
    	xCmMsg.ucInfoType = IFX_CM_SIP_CFG_USER;
    	xCmMsg.ucChannel = 0;
    
        if (IFX_CM_RecvDataFromCM (&xCmMsg) != IFX_CM_SUCCESS)
        {
            snmp_log(LOG_ERR,"ifxCodecTable: Fail to receive data from CM\n");
        }

        pstVoipCodec[i]->ulEndPointIdx = xCmMsg.ucChannel;
        strncpy (pstVoipCodec[i]->cUserName,
                 xCmMsg.uxData.xSipUserCfg.acUserName,
                 strlen(xCmMsg.uxData.xSipUserCfg.acUserName));
        strncpy (pstVoipCodec[i]->cDomainName,
                 xCmMsg.uxData.xSipUserCfg.acDomain,
                 strlen(xCmMsg.uxData.xSipUserCfg.acDomain));

      	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
    	xCmMsg.ucInfoType = IFX_CM_MEDIA_CONFIG;
    	xCmMsg.ucChannel = 0;
    
        if (IFX_CM_RecvDataFromCM (&xCmMsg) != IFX_CM_SUCCESS)
        {
            snmp_log(LOG_ERR,"ifxCodecTable: Fail to receive data from CM\n");
        }

        pstVoipCodec[i]->ulIndex = i;
        pstVoipCodec[i]->ulMediaBandwidth = xCmMsg.uxData.xMediaCfg.unMediaBw;
        pstVoipCodec[i]->ulCodecName =
            xCmMsg.uxData.xMediaCfg.xCodecList.axCodec[i].uiCodec;
        pstVoipCodec[i]->ulPayloadType = 
            xCmMsg.uxData.xMediaCfg.xCodecList.axCodec[i].ucDynPT;
        pstVoipCodec[i]->ulPriority = i;
        pstVoipCodec[i]->ulFrameSize = 
            xCmMsg.uxData.xMediaCfg.xCodecList.axCodec[i].ucFrameSize;

        if (xCmMsg.uxData.xMediaCfg.uiFwSupCodec &
            pstVoipCodec[i]->ulCodecName)
        {
            pstVoipCodec[i]->lRowStatus = ROWSTATUS_ACTIVE;
        }
        else
        {
            pstVoipCodec[i]->lRowStatus = ROWSTATUS_NOTINSERVICE;
        }
    }
}

/*
 * ===========================================================================
 *                          LOCAL FUNCTIONS
 * ===========================================================================
*/
/** returns the first data point within the ifxCodecTable table data.

    Set the my_loop_context variable to the first data point structure
    of your choice (from which you can find the next one).  This could
    be anything from the first node in a linked list, to an integer
    pointer containing the beginning of an array variable.

    Set the my_data_context variable to something to be returned to
    you later that will provide you with the data to return in a given
    row.  This could be the same pointer as what my_loop_context is
    set to, or something different.

    The put_index_data variable contains a list of snmp variable
    bindings, one for each index in your table.  Set the values of
    each appropriately according to the data matching the first row
    and return the put_index_data variable at the end of the function.
*/
netsnmp_variable_list *
ifxCodecTable_get_first_data_point(void **my_loop_context,
                                   void **my_data_context,
                                   netsnmp_variable_list * put_index_data,
                                   netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxCodecTable_get_first_data_point ****\n"); */
    int     *position;

    /* we could do this with a file-static variable, but for learning
       purposes we'll use memory allocation to demonstrate simplistic
       freeing of a loop_context */
    position = (int *)malloc(sizeof(int));
    if (!position)
        return NULL;

    ifxCodecTable_get_data();

    if (!pstVoipCodec)
    {
        snmp_log(LOG_ERR, "ifxCodecTable: None of row for this table.\n");
        free(position);
        return NULL;
    }

    /* We use the positinonal count as our loop context */
    *position = 0;
    *my_loop_context = position;

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = pstVoipCodec[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxCodecTable_set_indexes(pstVoipCodec[*position],
                                     put_index_data);
}

/** functionally the same as ifxCodecTable_get_first_data_point, but
   my_loop_context has already been set to a previous value and should
   be updated to the next in the list.  For example, if it was a
   linked list, you might want to cast it to your local data type and
   then return my_loop_context->next.  The my_data_context pointer
   should be set to something you need later and the indexes in
   put_index_data updated again. */
netsnmp_variable_list *
ifxCodecTable_get_next_data_point(void **my_loop_context,
                                  void **my_data_context,
                                  netsnmp_variable_list * put_index_data,
                                  netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxCodecTable_get_next_data_point ****\n"); */
    int *position = (int *) *my_loop_context;

    /* make sure we were called correctly */
    if (!position)
        return NULL;
    
    /* go to the next entry in the list */
    (*position)++;

    /* Are we beyond the end? */
    if (*position >= nEntryNum)
    {
        /* End of entry.  stop here by returning NULL */
        free(position);
        ifxGetCodecListCount();
        *my_loop_context = NULL;
        *my_data_context = NULL;
        return NULL;
    }

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = pstVoipCodec[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxCodecTable_set_indexes(pstVoipCodec[*position],
                                     put_index_data);
}

/** Create a data_context for non-existent rows that SETs are performed on.
 *  return a void * pointer which will be passed to subsequent get_XXX
 *  and set_XXX functions for data retrival and modification during
 *  this SET request.
 *
 *  The indexes are encoded (in order) into the index_data pointer,
 *  and the column object which triggered the row creation is available
 *  via the column parameter, if it would be helpful to use that information.
 */
void           *
ifxCodecTable_create_data_context(netsnmp_variable_list * index_data,
                                  int column)
{
    return NULL;                /* XXX: you likely want to return a real pointer */
}

/** If the implemented set_* functions don't operate directly on the
   real-live data (which is actually recommended), then this function
   can be used to take a given my_data_context pointer and "commit" it
   to whereever the modified data needs to be put back to.  For
   example, if this was a routing table you could publish the modified
   routes back into the kernel at this point.

   new_or_del will be set to 1 if new, or -1 if it should be deleted
   or 0 if it is just a modification of an existing row.

   If you free the data yourself, make sure to *my_data_context = NULL */
int
ifxCodecTable_commit_row(void **my_data_context, int new_or_del)
{
    /** Add any necessary commit code here */
    /*
     */

    /*
     * return no errors.  And there shouldn't be any!!!  Ever!!!  You
     * should have checked the values long before this. 
     */
    return SNMP_ERR_NOERROR;
}


/*
 * User-defined data access functions (per column) for data in table ifxCodecTable 
 */
/*
 * NOTE:
 * - these get_ routines MUST return data that will not be freed (ie,
 *   use static variables or persistent data).  It will be copied, if
 *   needed, immediately after the get_ routine has been called.
 * - these SET routines must copy the incoming data and can not take
 *   ownership of the memory passed in by the val pointer.
 */
/** XXX: return a data pointer to the data for the codecMediaBw column and set
         ret_len to its proper size in bytes. */
u_long         *
get_codecMediaBw(void *data_context, size_t *ret_len)
{
    VOIPCODECCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulMediaBandwidth);
    return &datainfo->ulMediaBandwidth;
}

/** XXX: Set the value of the codecMediaBw column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_codecMediaBw(void *data_context, u_long * val, size_t val_len)
{
    VOIPCODECCFG_S *datainfo = data_context;
    datainfo->ulMediaBandwidth = 80;
    memcpy(&datainfo->ulMediaBandwidth, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the codecName column and set
         ret_len to its proper size in bytes. */
u_long         *
get_codecName(void *data_context, size_t * ret_len)
{
    VOIPCODECCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulCodecName);
    return &datainfo->ulCodecName;
}

/** XXX: Set the value of the codecName column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_codecName(void *data_context, u_long * val, size_t val_len)
{
    VOIPCODECCFG_S *datainfo = data_context;
    memcpy(&datainfo->ulCodecName, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the codecPayloadType column and set
         ret_len to its proper size in bytes. */
u_long         *
get_codecPayloadType(void *data_context, size_t * ret_len)
{
    VOIPCODECCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulPayloadType);
    return &datainfo->ulPayloadType;
}

/** XXX: Set the value of the codecPayloadType column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_codecPayloadType(void *data_context, u_long * val, size_t val_len)
{
    VOIPCODECCFG_S *datainfo = data_context;
    datainfo->ulPayloadType = 96;
    memcpy(&datainfo->ulPayloadType, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the codecPriority column and set
         ret_len to its proper size in bytes. */
u_long         *
get_codecPriority(void *data_context, size_t * ret_len)
{
    VOIPCODECCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulPriority);
    return &datainfo->ulPriority;
}

/** XXX: Set the value of the codecPriority column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_codecPriority(void *data_context, u_long * val, size_t val_len)
{
    VOIPCODECCFG_S *datainfo = data_context;
    datainfo->ulPriority = 0;
    memcpy(&datainfo->ulPriority, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the codecFrameSize column and set
         ret_len to its proper size in bytes. */
u_long         *
get_codecFrameSize(void *data_context, size_t * ret_len)
{
    VOIPCODECCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulFrameSize);
    return &datainfo->ulFrameSize;
}

/** XXX: Set the value of the codecFrameSize column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_codecFrameSize(void *data_context, u_long * val, size_t val_len)
{
    VOIPCODECCFG_S *datainfo = data_context;
    datainfo->ulFrameSize = CODECFRAMESIZE_5;
    memcpy(&datainfo->ulFrameSize, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the codecRowStatus column and set
         ret_len to its proper size in bytes. */
long           *
get_codecRowStatus(void *data_context, size_t * ret_len)
{
    VOIPCODECCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->lRowStatus);
    return &datainfo->lRowStatus;
}

/** XXX: Set the value of the codecRowStatus column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_codecRowStatus(void *data_context, long *val, size_t val_len)
{
    VOIPCODECCFG_S *datainfo = data_context;
    datainfo->lRowStatus = ROWSTATUS_ACTIVE;
    memcpy(&datainfo->lRowStatus, val, val_len);
    return SNMP_ERR_NOERROR;
}
