/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-VOIP-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxMediaSecProfTable_access.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.9 2004/10/14 12:57:33 dts12 Exp $
*/
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "ifxMediaSecProfTable_access.h"

/*
 * ===========================================================================
 *                          GLOBAL DEFINITIONS
 * ===========================================================================
*/
static VOIPMEDIASECPROFCFG_S    stCfg[IFX_CM_MAX_ENDPTS];
static x_IFX_CM_Msg             g_xCmMsg;

/*
 * ===========================================================================
 *                          LOCAL FUNCTIONS
 * ===========================================================================
*/
netsnmp_variable_list *
ifxMediaSecProfTable_set_indexes(VOIPMEDIASECPROFCFG_S *datainfo,
                                 netsnmp_variable_list *put_index_data)
{
    /* printf("**** ifxMediaSecProfTable_set_indexes ****\n"); */
    netsnmp_variable_list   *vptr;

    /* endPointIdx */
    vptr = put_index_data;
    snmp_set_var_value(vptr, (u_char *) &datainfo->ulEndPointIdx,
                       sizeof(datainfo->ulEndPointIdx) );

    /* suUserName */
    vptr = vptr->next_variable;
    snmp_set_var_value(vptr, (u_char *) &datainfo->cUserName,
                       strlen(datainfo->cUserName) );

    /* suDomainName */
    vptr = vptr->next_variable;
    snmp_set_var_value(vptr, (u_char *) &datainfo->cDomainName,
                       strlen(datainfo->cDomainName) );

    /* mspIndex */
    vptr = vptr->next_variable;
    snmp_set_var_value(vptr, (u_char *) &datainfo->ulIndex ,
                       sizeof(datainfo->ulIndex) );

    return put_index_data;
}

void  *
ifxMediaSecProfTable_get_data(void)
{
    int              i = 0;

    for ( i = 0; i < IFX_CM_MAX_ENDPTS; i++)
    {
        memset (&stCfg[i], 0x00, sizeof(VOIPMEDIASECPROFCFG_S));
        memset (&g_xCmMsg, 0x00, sizeof(x_IFX_CM_Msg));

       	g_xCmMsg.ucMsgType = IFX_CM_GET_REQ;
    	g_xCmMsg.ucInfoType = IFX_CM_SIP_CFG_USER;
    	g_xCmMsg.ucChannel = i;
    
        if (IFX_CM_RecvDataFromCM (&g_xCmMsg) != IFX_CM_SUCCESS)
        {
            snmp_log(LOG_ERR,"ifxMediaSecProfTable: Fail to receive data from CM\n");
        }

        stCfg[i].ulEndPointIdx = g_xCmMsg.ucChannel;
        strncpy (stCfg[i].cUserName,
                 g_xCmMsg.uxData.xSipUserCfg.acUserName,
                 strlen(g_xCmMsg.uxData.xSipUserCfg.acUserName));
        strncpy (stCfg[i].cDomainName,
                 g_xCmMsg.uxData.xSipUserCfg.acDomain,
                 strlen(g_xCmMsg.uxData.xSipUserCfg.acDomain));

      	g_xCmMsg.ucMsgType = IFX_CM_GET_REQ;
    	g_xCmMsg.ucInfoType = IFX_CM_SRTP_KEY_CFG;
    	g_xCmMsg.ucChannel = i;
    
        if (IFX_CM_RecvDataFromCM (&g_xCmMsg) != IFX_CM_SUCCESS)
        {
            snmp_log(LOG_ERR,"ifxMediaSecProfTable: Fail to receive data from CM\n");
        }

        stCfg[i].ulIndex = i;
        stCfg[i].ulSRTPEncry = g_xCmMsg.uxData.xSrtpKeyCfg.ucEncrAlgo;
        stCfg[i].ulSRTPAuth = g_xCmMsg.uxData.xSrtpKeyCfg.ucAuthAlgo;
        strncpy (stCfg[i].cSRTPMasterKy,
                 g_xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].acMasterKey,
                 strlen(g_xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].
                        acMasterKey));
        strncpy (stCfg[i].cSRTPMasterSalt,
                 g_xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].acMasterSalt,
                 strlen(g_xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].
                        acMasterSalt));
        stCfg[i].ulSRTPFlag = g_xCmMsg.uxData.xSrtpKeyCfg.
                              xMasterCryptoParam[0].ucMkiIndicator;
        stCfg[i].ulSRTPMKI = g_xCmMsg.uxData.xSrtpKeyCfg.
                             xMasterCryptoParam[0].uiMkiValue;

        memset (&g_xCmMsg, 0x00, sizeof(x_IFX_CM_Msg));
      	g_xCmMsg.ucMsgType = IFX_CM_GET_REQ;
    	g_xCmMsg.ucInfoType = IFX_CM_SRTCP_KEY_CFG;
    	g_xCmMsg.ucChannel = i;
    
        if (IFX_CM_RecvDataFromCM (&g_xCmMsg) != IFX_CM_SUCCESS)
        {
            snmp_log(LOG_ERR,"ifxMediaSecProfTable: Fail to receive data from CM\n");
        }

        stCfg[i].ulSRTCPEncry = g_xCmMsg.uxData.xSrtpKeyCfg.ucEncrAlgo;
        stCfg[i].ulSRTCPAuth = g_xCmMsg.uxData.xSrtpKeyCfg.ucAuthAlgo;
        strncpy (stCfg[i].cSRTCPMasterKy,
                 g_xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].acMasterKey,
                 strlen(g_xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].
                        acMasterKey));
        strncpy (stCfg[i].cSRTCPMasterSalt,
                 g_xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].acMasterSalt,
                 strlen(g_xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].
                        acMasterSalt));
        stCfg[i].ulSRTCPFlag = g_xCmMsg.uxData.xSrtpKeyCfg.
                              xMasterCryptoParam[0].ucMkiIndicator;
        stCfg[i].ulSRTCPMKI = g_xCmMsg.uxData.xSrtpKeyCfg.
                             xMasterCryptoParam[0].uiMkiValue;
        stCfg[i].lRowStatus = ROWSTATUS_ACTIVE; /* sharon TBM */
    }
}

/** returns the first data point within the ifxMediaSecProfTable table data.

    Set the my_loop_context variable to the first data point structure
    of your choice (from which you can find the next one).  This could
    be anything from the first node in a linked list, to an integer
    pointer containing the beginning of an array variable.

    Set the my_data_context variable to something to be returned to
    you later that will provide you with the data to return in a given
    row.  This could be the same pointer as what my_loop_context is
    set to, or something different.

    The put_index_data variable contains a list of snmp variable
    bindings, one for each index in your table.  Set the values of
    each appropriately according to the data matching the first row
    and return the put_index_data variable at the end of the function.
*/
netsnmp_variable_list *
ifxMediaSecProfTable_get_first_data_point(void **my_loop_context,
                                          void **my_data_context,
                                          netsnmp_variable_list *
                                          put_index_data,
                                          netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxMediaSecProfTable_get_first_data_point ****\n"); */
    int     *position;

    /* we could do this with a file-static variable, but for learning
       purposes we'll use memory allocation to demonstrate simplistic
       freeing of a loop_context */
    position = (int *)malloc(sizeof(int));
    if (!position)
        return NULL;

    ifxMediaSecProfTable_get_data();

    /* We use the positinonal count as our loop context */
    *position = 0;
    *my_loop_context = position;

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = &stCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxMediaSecProfTable_set_indexes(&stCfg[*position], put_index_data);
}

/** functionally the same as ifxMediaSecProfTable_get_first_data_point, but
   my_loop_context has already been set to a previous value and should
   be updated to the next in the list.  For example, if it was a
   linked list, you might want to cast it to your local data type and
   then return my_loop_context->next.  The my_data_context pointer
   should be set to something you need later and the indexes in
   put_index_data updated again. */
netsnmp_variable_list *
ifxMediaSecProfTable_get_next_data_point(void **my_loop_context,
                                         void **my_data_context,
                                         netsnmp_variable_list *
                                         put_index_data,
                                         netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxTelUriTable_get_next_data_point ****\n"); */
    int *position = (int *) *my_loop_context;

    /* make sure we were called correctly */
    if (!position)
        return NULL;
    
    /* go to the next entry in the list */
    (*position)++;

    /* Are we beyond the end? */
    if (*position >= IFX_CM_MAX_ENDPTS)
    {
        /* End of entry.  stop here by returning NULL */
        free(position);
        *my_loop_context = NULL;
        *my_data_context = NULL;
        return NULL;
    }

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = &stCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxMediaSecProfTable_set_indexes(&stCfg[*position], put_index_data);
}

/** Create a data_context for non-existent rows that SETs are performed on.
 *  return a void * pointer which will be passed to subsequent get_XXX
 *  and set_XXX functions for data retrival and modification during
 *  this SET request.
 *
 *  The indexes are encoded (in order) into the index_data pointer,
 *  and the column object which triggered the row creation is available
 *  via the column parameter, if it would be helpful to use that information.
 */
void           *
ifxMediaSecProfTable_create_data_context(netsnmp_variable_list *
                                         index_data, int column)
{
    return NULL;                /* XXX: you likely want to return a real pointer */
}

/** If the implemented set_* functions don't operate directly on the
   real-live data (which is actually recommended), then this function
   can be used to take a given my_data_context pointer and "commit" it
   to whereever the modified data needs to be put back to.  For
   example, if this was a routing table you could publish the modified
   routes back into the kernel at this point.

   new_or_del will be set to 1 if new, or -1 if it should be deleted
   or 0 if it is just a modification of an existing row.

   If you free the data yourself, make sure to *my_data_context = NULL */
int
ifxMediaSecProfTable_commit_row(void **my_data_context, int new_or_del)
{
    VOIPMEDIASECPROFCFG_S *datactx = *my_data_context;
    int                   i = 0;

    /* printf("**** ifxMediaSecProfTable_commit_row ****\n"); */

    if (new_or_del == -1)
    {
        return SNMP_ERR_NOERROR; /* no change in the value */
    }

    for ( i = 0; i < IFX_CM_MAX_ENDPTS; i++)
    {
        if (i == datactx->ulIndex)
        {
            memset (&g_xCmMsg, 0x00, sizeof(x_IFX_CM_Msg));

           	g_xCmMsg.ucMsgType = IFX_CM_SET_REQ;
        	g_xCmMsg.ucInfoType = IFX_CM_SRTP_KEY_CFG;
        	g_xCmMsg.ucChannel = i;
        	g_xCmMsg.uxData.xSrtpKeyCfg.ucEncrAlgo = datactx->ulSRTPEncry;
        	g_xCmMsg.uxData.xSrtpKeyCfg.ucAuthAlgo = datactx->ulSRTPAuth;
            strncpy (g_xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].acMasterKey,
                     datactx->cSRTPMasterKy,
                     strlen(datactx->cSRTPMasterKy));
            strncpy (g_xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].acMasterSalt,
                     datactx->cSRTPMasterSalt,
                     strlen(datactx->cSRTPMasterSalt));
            g_xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].ucMkiIndicator =
                datactx->ulSRTPFlag;
            g_xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].uiMkiValue =
                datactx->ulSRTPMKI;

            if (IFX_CM_SendDataToCM (&g_xCmMsg) != IFX_CM_SUCCESS)
            {
                snmp_log(LOG_ERR, "ifxMediaSecProfTable: Fail to send RM-Codec data to CM");
                return SNMP_ERR_COMMITFAILED;
            }

            memset (&g_xCmMsg, 0x00, sizeof(x_IFX_CM_Msg));

           	g_xCmMsg.ucMsgType = IFX_CM_SET_REQ;
        	g_xCmMsg.ucInfoType = IFX_CM_SRTCP_KEY_CFG;
        	g_xCmMsg.ucChannel = i;
        	g_xCmMsg.uxData.xSrtpKeyCfg.ucEncrAlgo = datactx->ulSRTCPEncry;
        	g_xCmMsg.uxData.xSrtpKeyCfg.ucAuthAlgo = datactx->ulSRTCPAuth;
            strncpy (g_xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].acMasterKey,
                     datactx->cSRTCPMasterKy,
                     strlen(datactx->cSRTCPMasterKy));
            strncpy (g_xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].acMasterSalt,
                     datactx->cSRTCPMasterSalt,
                     strlen(datactx->cSRTCPMasterSalt));
            g_xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].ucMkiIndicator =
                datactx->ulSRTCPFlag;
            g_xCmMsg.uxData.xSrtpKeyCfg.xMasterCryptoParam[0].uiMkiValue =
                datactx->ulSRTCPMKI;

            if (IFX_CM_SendDataToCM (&g_xCmMsg) != IFX_CM_SUCCESS)
            {
                snmp_log(LOG_ERR, "ifxMediaSecProfTable: Fail to send RM-Codec data to CM");
                return SNMP_ERR_COMMITFAILED;
            }
        }
    }

    /*
     * return no errors.  And there shouldn't be any!!!  Ever!!!  You
     * should have checked the values long before this. 
     */
    return SNMP_ERR_NOERROR;
}


/*
 * User-defined data access functions (per column) for data in table ifxMediaSecProfTable 
 */
/*
 * NOTE:
 * - these get_ routines MUST return data that will not be freed (ie,
 *   use static variables or persistent data).  It will be copied, if
 *   needed, immediately after the get_ routine has been called.
 * - these SET routines must copy the incoming data and can not take
 *   ownership of the memory passed in by the val pointer.
 */
/** XXX: return a data pointer to the data for the mspSRTPEncryAlgo column and set
         ret_len to its proper size in bytes. */
u_long         *
get_mspSRTPEncryAlgo(void *data_context, size_t *ret_len)
{
    VOIPMEDIASECPROFCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulSRTPEncry);
    return &datainfo->ulSRTPEncry;
}

/** XXX: Set the value of the mspSRTPEncryAlgo column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_mspSRTPEncryAlgo(void *data_context, u_long * val, size_t val_len)
{
    VOIPMEDIASECPROFCFG_S *datainfo = data_context;
    datainfo->ulSRTPEncry = MSPENCRYALGO_NULL;
    memcpy(&datainfo->ulSRTPEncry, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the mspSRTPAuthAlgo column and set
         ret_len to its proper size in bytes. */
u_long         *
get_mspSRTPAuthAlgo(void *data_context, size_t *ret_len)
{
    VOIPMEDIASECPROFCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulSRTPAuth);
    return &datainfo->ulSRTPAuth;
}

/** XXX: Set the value of the mspSRTPAuthAlgo column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_mspSRTPAuthAlgo(void *data_context, u_long * val, size_t val_len)
{
    VOIPMEDIASECPROFCFG_S *datainfo = data_context;
    datainfo->ulSRTPAuth = MSPAUTHALGO_NULL;
    memcpy(&datainfo->ulSRTPAuth, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the mspSRTPMasterKey column and set
         ret_len to its proper size in bytes. */
char           *
get_mspSRTPMasterKey(void *data_context, size_t *ret_len)
{
    VOIPMEDIASECPROFCFG_S   *datainfo = data_context;
	*ret_len = strlen(datainfo->cSRTPMasterKy);
    return (char *)&datainfo->cSRTPMasterKy;
}

/** XXX: Set the value of the mspSRTPMasterKey column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_mspSRTPMasterKey(void *data_context, char *val, size_t val_len)
{
    VOIPMEDIASECPROFCFG_S *datainfo = data_context;
    memset(&datainfo->cSRTPMasterKy, 0x00, sizeof(datainfo->cSRTPMasterKy));
    memcpy(&datainfo->cSRTPMasterKy, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the mspSRTPMasterSalt column and set
         ret_len to its proper size in bytes. */
char           *
get_mspSRTPMasterSalt(void *data_context, size_t *ret_len)
{
    VOIPMEDIASECPROFCFG_S   *datainfo = data_context;
	*ret_len = strlen(datainfo->cSRTPMasterSalt);
    return (char *)&datainfo->cSRTPMasterSalt;
}

/** XXX: Set the value of the mspSRTPMasterSalt column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_mspSRTPMasterSalt(void *data_context, char *val, size_t val_len)
{
    VOIPMEDIASECPROFCFG_S *datainfo = data_context;
    memset(&datainfo->cSRTPMasterSalt, 0x00, sizeof(datainfo->cSRTPMasterSalt));
    memcpy(&datainfo->cSRTPMasterSalt, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the mspSRTPMKIFlag column and set
         ret_len to its proper size in bytes. */
u_long         *
get_mspSRTPMKIFlag(void *data_context, size_t *ret_len)
{
    VOIPMEDIASECPROFCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulSRTPFlag);
    return &datainfo->ulSRTPFlag;
}

/** XXX: Set the value of the mspSRTPMKIFlag column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_mspSRTPMKIFlag(void *data_context, u_long * val, size_t val_len)
{
    VOIPMEDIASECPROFCFG_S *datainfo = data_context;
    datainfo->ulSRTPFlag = IFX_CM_OFF;
    memcpy(&datainfo->ulSRTPFlag, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the mspSRTPMKI column and set
         ret_len to its proper size in bytes. */
u_long         *
get_mspSRTPMKI(void *data_context, size_t *ret_len)
{
    VOIPMEDIASECPROFCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulSRTPMKI);
    return &datainfo->ulSRTPMKI;
}

/** XXX: Set the value of the mspSRTPMKI column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_mspSRTPMKI(void *data_context, u_long * val, size_t val_len)
{
    VOIPMEDIASECPROFCFG_S *datainfo = data_context;
    datainfo->ulSRTPMKI = 0;
    memcpy(&datainfo->ulSRTPMKI, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the mspSRTCPEncryAlgo column and set
         ret_len to its proper size in bytes. */
u_long         *
get_mspSRTCPEncryAlgo(void *data_context, size_t *ret_len)
{
    VOIPMEDIASECPROFCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulSRTCPEncry);
    return &datainfo->ulSRTCPEncry;
}

/** XXX: Set the value of the mspSRTCPEncryAlgo column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_mspSRTCPEncryAlgo(void *data_context, u_long * val, size_t val_len)
{
    VOIPMEDIASECPROFCFG_S *datainfo = data_context;
    datainfo->ulSRTCPEncry = MSPENCRYALGO_NULL;
    memcpy(&datainfo->ulSRTCPEncry, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the mspSRTCPAuthAlgo column and set
         ret_len to its proper size in bytes. */
u_long         *
get_mspSRTCPAuthAlgo(void *data_context, size_t *ret_len)
{
    VOIPMEDIASECPROFCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulSRTCPAuth);
    return &datainfo->ulSRTCPAuth;
}

/** XXX: Set the value of the mspSRTCPAuthAlgo column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_mspSRTCPAuthAlgo(void *data_context, u_long * val, size_t val_len)
{
    VOIPMEDIASECPROFCFG_S *datainfo = data_context;
    datainfo->ulSRTCPAuth = MSPAUTHALGO_NULL;
    memcpy(&datainfo->ulSRTCPAuth, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the mspSRTCPMasterKey column and set
         ret_len to its proper size in bytes. */
char           *
get_mspSRTCPMasterKey(void *data_context, size_t *ret_len)
{
    VOIPMEDIASECPROFCFG_S   *datainfo = data_context;
	*ret_len = strlen(datainfo->cSRTCPMasterKy);
    return (char *)&datainfo->cSRTCPMasterKy;
}

/** XXX: Set the value of the mspSRTCPMasterKey column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_mspSRTCPMasterKey(void *data_context, char *val, size_t val_len)
{
    VOIPMEDIASECPROFCFG_S *datainfo = data_context;
    memset(&datainfo->cSRTCPMasterKy, 0x00, sizeof(datainfo->cSRTCPMasterKy));
    memcpy(&datainfo->cSRTCPMasterKy, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the mspSRTCPMasterSalt column and set
         ret_len to its proper size in bytes. */
char           *
get_mspSRTCPMasterSalt(void *data_context, size_t *ret_len)
{
    VOIPMEDIASECPROFCFG_S   *datainfo = data_context;
	*ret_len = strlen(datainfo->cSRTCPMasterSalt);
    return (char *)&datainfo->cSRTCPMasterSalt;
}

/** XXX: Set the value of the mspSRTCPMasterSalt column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_mspSRTCPMasterSalt(void *data_context, char *val, size_t val_len)
{
    VOIPMEDIASECPROFCFG_S *datainfo = data_context;
    memset(&datainfo->cSRTCPMasterSalt, 0x00, sizeof(datainfo->cSRTCPMasterSalt));
    memcpy(&datainfo->cSRTCPMasterSalt, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the mspSRTCPMKIFlag column and set
         ret_len to its proper size in bytes. */
u_long         *
get_mspSRTCPMKIFlag(void *data_context, size_t *ret_len)
{
    VOIPMEDIASECPROFCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulSRTCPFlag);
    return &datainfo->ulSRTCPFlag;
}

/** XXX: Set the value of the mspSRTCPMKIFlag column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_mspSRTCPMKIFlag(void *data_context, u_long * val, size_t val_len)
{
    VOIPMEDIASECPROFCFG_S *datainfo = data_context;
    datainfo->ulSRTCPFlag = IFX_CM_OFF;
    memcpy(&datainfo->ulSRTCPFlag, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the mspSRTCPMKI column and set
         ret_len to its proper size in bytes. */
u_long         *
get_mspSRTCPMKI(void *data_context, size_t *ret_len)
{
    VOIPMEDIASECPROFCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulSRTCPMKI);
    return &datainfo->ulSRTCPMKI;
}

/** XXX: Set the value of the mspSRTCPMKI column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_mspSRTCPMKI(void *data_context, u_long * val, size_t val_len)
{
    VOIPMEDIASECPROFCFG_S *datainfo = data_context;
    datainfo->ulSRTCPMKI = 0;
    memcpy(&datainfo->ulSRTCPMKI, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the mspRowStatus column and set
         ret_len to its proper size in bytes. */
long           *
get_mspRowStatus(void *data_context, size_t *ret_len)
{
    VOIPMEDIASECPROFCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->lRowStatus);
    return &datainfo->lRowStatus;
}

/** XXX: Set the value of the mspRowStatus column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_mspRowStatus(void *data_context, long *val, size_t val_len)
{
    VOIPMEDIASECPROFCFG_S *datainfo = data_context;
    datainfo->lRowStatus = ROWSTATUS_ACTIVE;
    memcpy(&datainfo->lRowStatus, val, val_len);
    return SNMP_ERR_NOERROR;
}
