/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-VOIP-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxPhoneProfTable_access.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.9 2004/10/14 12:57:33 dts12 Exp $
*/
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "ifxPhoneProfTable_access.h"

/*
 * ===========================================================================
 *                          GLOBAL DEFINITIONS
 * ===========================================================================
*/
static VOIPPHONEPROFCFG_S      stCfg[IFX_CM_MAX_ENDPTS];
static x_IFX_CM_Msg            g_xCmMsg;

/*
 * ===========================================================================
 *                          LOCAL FUNCTIONS
 * ===========================================================================
*/
netsnmp_variable_list *
ifxPhoneProfTable_set_indexes(VOIPPHONEPROFCFG_S *datainfo,
                              netsnmp_variable_list *put_index_data)
{
    /* printf("**** ifxPhoneProfTable_set_indexes ****\n"); */
    netsnmp_variable_list   *vptr;

    /* endPointIdx */
    vptr = put_index_data;
    snmp_set_var_value(vptr, (u_char *) &datainfo->ulEndPointIdx,
                       sizeof(datainfo->ulEndPointIdx) );

    /* suUserName */
    vptr = vptr->next_variable;
    snmp_set_var_value(vptr, (u_char *) &datainfo->cUserName,
                       strlen(datainfo->cUserName) );

    /* suDomainName */
    vptr = vptr->next_variable;
    snmp_set_var_value(vptr, (u_char *) &datainfo->cDomainName,
                       strlen(datainfo->cDomainName) );

    /* ppIndex */
    vptr = vptr->next_variable;
    snmp_set_var_value(vptr, (u_char *) &datainfo->ulIndex ,
                       sizeof(datainfo->ulIndex) );

    return put_index_data;
}

void  *
ifxPhoneProfTable_get_data(void)
{
    int              i = 0;

    for ( i = 0; i < IFX_CM_MAX_ENDPTS; i++)
    {
        memset (&stCfg[i], 0x00, sizeof(VOIPPHONEPROFCFG_S));
        memset (&g_xCmMsg, 0x00, sizeof(x_IFX_CM_Msg));

       	g_xCmMsg.ucMsgType = IFX_CM_GET_REQ;
    	g_xCmMsg.ucInfoType = IFX_CM_SIP_CFG_USER;
    	g_xCmMsg.ucChannel = i;
    
        if (IFX_CM_RecvDataFromCM (&g_xCmMsg) != IFX_CM_SUCCESS)
        {
            snmp_log(LOG_ERR,"ifxPhoneProfTable: Fail to receive data from CM\n");
        }

        stCfg[i].ulEndPointIdx = g_xCmMsg.ucChannel;
        strncpy (stCfg[i].cUserName,
                 g_xCmMsg.uxData.xSipUserCfg.acUserName,
                 strlen(g_xCmMsg.uxData.xSipUserCfg.acUserName));
        strncpy (stCfg[i].cDomainName,
                 g_xCmMsg.uxData.xSipUserCfg.acDomain,
                 strlen(g_xCmMsg.uxData.xSipUserCfg.acDomain));

      	g_xCmMsg.ucMsgType = IFX_CM_GET_REQ;
    	g_xCmMsg.ucInfoType = IFX_CM_APP_CALL_CFG;
    	g_xCmMsg.ucChannel = i;
    
        if (IFX_CM_RecvDataFromCM (&g_xCmMsg) != IFX_CM_SUCCESS)
        {
            snmp_log(LOG_ERR,"ifxPhoneProfTable: Fail to receive data from CM\n");
        }

        stCfg[i].ulIndex = i;
        stCfg[i].ulSupp = g_xCmMsg.uxData.xCallCfg.xCallIdCfg.ucCallIdFlag;
        stCfg[i].ulDND = g_xCmMsg.uxData.xCallCfg.ucDndFlag;

        if (stCfg[i].ulSupp == IFX_CM_ON &&
            stCfg[i].ulDND == IFX_CM_ON)
            stCfg[i].lRowStatus = ROWSTATUS_ACTIVE;
        else
            stCfg[i].lRowStatus = ROWSTATUS_NOTINSERVICE;
    }
}

/** returns the first data point within the ifxPhoneProfTable table data.

    Set the my_loop_context variable to the first data point structure
    of your choice (from which you can find the next one).  This could
    be anything from the first node in a linked list, to an integer
    pointer containing the beginning of an array variable.

    Set the my_data_context variable to something to be returned to
    you later that will provide you with the data to return in a given
    row.  This could be the same pointer as what my_loop_context is
    set to, or something different.

    The put_index_data variable contains a list of snmp variable
    bindings, one for each index in your table.  Set the values of
    each appropriately according to the data matching the first row
    and return the put_index_data variable at the end of the function.
*/
netsnmp_variable_list *
ifxPhoneProfTable_get_first_data_point(void **my_loop_context,
                                       void **my_data_context,
                                       netsnmp_variable_list *
                                       put_index_data,
                                       netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxPhoneProfTable_get_first_data_point ****\n"); */
    int     *position;

    /* we could do this with a file-static variable, but for learning
       purposes we'll use memory allocation to demonstrate simplistic
       freeing of a loop_context */
    position = (int *)malloc(sizeof(int));
    if (!position)
        return NULL;

    ifxPhoneProfTable_get_data();

    /* We use the positinonal count as our loop context */
    *position = 0;
    *my_loop_context = position;

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = &stCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxPhoneProfTable_set_indexes(&stCfg[*position], put_index_data);
}

/** functionally the same as ifxPhoneProfTable_get_first_data_point, but
   my_loop_context has already been set to a previous value and should
   be updated to the next in the list.  For example, if it was a
   linked list, you might want to cast it to your local data type and
   then return my_loop_context->next.  The my_data_context pointer
   should be set to something you need later and the indexes in
   put_index_data updated again. */
netsnmp_variable_list *
ifxPhoneProfTable_get_next_data_point(void **my_loop_context,
                                      void **my_data_context,
                                      netsnmp_variable_list *
                                      put_index_data,
                                      netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxPhoneProfTable_get_next_data_point ****\n"); */
    int *position = (int *) *my_loop_context;

    /* make sure we were called correctly */
    if (!position)
        return NULL;
    
    /* go to the next entry in the list */
    (*position)++;

    /* Are we beyond the end? */
    if (*position >= IFX_CM_MAX_ENDPTS)
    {
        /* End of entry.  stop here by returning NULL */
        free(position);
        *my_loop_context = NULL;
        *my_data_context = NULL;
        return NULL;
    }

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = &stCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxPhoneProfTable_set_indexes(&stCfg[*position], put_index_data);
}

/** Create a data_context for non-existent rows that SETs are performed on.
 *  return a void * pointer which will be passed to subsequent get_XXX
 *  and set_XXX functions for data retrival and modification during
 *  this SET request.
 *
 *  The indexes are encoded (in order) into the index_data pointer,
 *  and the column object which triggered the row creation is available
 *  via the column parameter, if it would be helpful to use that information.
 */
void           *
ifxPhoneProfTable_create_data_context(netsnmp_variable_list * index_data,
                                      int column)
{
    return NULL;                /* XXX: you likely want to return a real pointer */
}

/** If the implemented set_* functions don't operate directly on the
   real-live data (which is actually recommended), then this function
   can be used to take a given my_data_context pointer and "commit" it
   to whereever the modified data needs to be put back to.  For
   example, if this was a routing table you could publish the modified
   routes back into the kernel at this point.

   new_or_del will be set to 1 if new, or -1 if it should be deleted
   or 0 if it is just a modification of an existing row.

   If you free the data yourself, make sure to *my_data_context = NULL */
int
ifxPhoneProfTable_commit_row(void **my_data_context, int new_or_del)
{
    VOIPPHONEPROFCFG_S    *datactx = *my_data_context;
    int                   i = 0;

    /* printf("**** ifxPhoneProfTable_commit_row ****\n"); */

    if (new_or_del == -1)
    {
        return SNMP_ERR_NOERROR; /* no change in the value */
    }

    for ( i = 0; i < IFX_CM_MAX_ENDPTS; i++)
    {
        if (i == datactx->ulIndex)
        {
            memset (&g_xCmMsg, 0x00, sizeof(x_IFX_CM_Msg));

           	g_xCmMsg.ucMsgType = IFX_CM_SET_REQ;
        	g_xCmMsg.ucInfoType = IFX_CM_APP_CALL_CFG;
        	g_xCmMsg.ucChannel = i;
            g_xCmMsg.uxData.xCallCfg.xCallIdCfg.ucCallIdFlag = datactx->ulSupp;
            g_xCmMsg.uxData.xCallCfg.ucDndFlag = datactx->ulDND;

            if (IFX_CM_SendDataToCM (&g_xCmMsg) != IFX_CM_SUCCESS)
            {
                snmp_log(LOG_ERR, "ifxPhoneProfTable: Fail to send RM-Codec data to CM");
                return SNMP_ERR_COMMITFAILED;
            }
        }
    }

    /*
     * return no errors.  And there shouldn't be any!!!  Ever!!!  You
     * should have checked the values long before this. 
     */
    return SNMP_ERR_NOERROR;
}


/*
 * User-defined data access functions (per column) for data in table ifxPhoneProfTable 
 */
/*
 * NOTE:
 * - these get_ routines MUST return data that will not be freed (ie,
 *   use static variables or persistent data).  It will be copied, if
 *   needed, immediately after the get_ routine has been called.
 * - these SET routines must copy the incoming data and can not take
 *   ownership of the memory passed in by the val pointer.
 */
/** XXX: return a data pointer to the data for the ppCallerIdSupp column and set
         ret_len to its proper size in bytes. */
u_long         *
get_ppCallerIdSupp(void *data_context, size_t *ret_len)
{
    VOIPPHONEPROFCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulSupp);
    return &datainfo->ulSupp;
}

/** XXX: Set the value of the ppCallerIdSupp column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_ppCallerIdSupp(void *data_context, u_long * val, size_t val_len)
{
    VOIPPHONEPROFCFG_S *datainfo = data_context;
    datainfo->ulSupp = IFX_CM_OFF;
    memcpy(&datainfo->ulSupp, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the ppDND column and set
         ret_len to its proper size in bytes. */
u_long         *
get_ppDND(void *data_context, size_t *ret_len)
{
    VOIPPHONEPROFCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulDND);
    return &datainfo->ulDND;
}

/** XXX: Set the value of the ppDND column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_ppDND(void *data_context, u_long * val, size_t val_len)
{
    VOIPPHONEPROFCFG_S *datainfo = data_context;
    datainfo->ulDND = IFX_CM_OFF;
    memcpy(&datainfo->ulDND, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the ppRowStatus column and set
         ret_len to its proper size in bytes. */
long           *
get_ppRowStatus(void *data_context, size_t *ret_len)
{
    VOIPPHONEPROFCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->lRowStatus);
    return &datainfo->lRowStatus;
}
