/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-VOIP-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxRtpPortRangeTable_checkfns.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.check_values.conf,v 1.8 2004/01/12 00:43:45 rstory Exp $
 */

/********************************************************************
 *                       NOTE   NOTE   NOTE
 *   This file is auto-generated and SHOULD NOT BE EDITED by hand.
 *   Modify the ifxRtpPortRangeTable_checkfns_local.[ch] files insead so that you
 *   can regenerate this one as mib2c improvements are made.
 ********************************************************************/

/*
 * standard headers 
 */
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include "ifxRtpPortRangeTable_checkfns.h"
#include "ifxRtpPortRangeTable_columns.h"

/** Decides if an incoming value for the rprStartRtpPort mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_rprStartRtpPort(int type, u_long * val, size_t val_len,
                      u_long * old_val, size_t old_val_len)
{
    int             ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_UNSIGNED)
        return SNMP_ERR_WRONGTYPE;

    if (!(*val >= 1024 && *val <= 65535) )
        return SNMP_ERR_WRONGVALUE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the rprEndRtpPort mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_rprEndRtpPort(int type, u_long * val, size_t val_len,
                    u_long * old_val, size_t old_val_len)
{
    int             ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_UNSIGNED)
        return SNMP_ERR_WRONGTYPE;

    if (!(*val >= 1024 && *val <= 65535) )
        return SNMP_ERR_WRONGVALUE;

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the rprStrictSrtp mib node is legal.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_rprStrictSrtp(int type, u_long * val, size_t val_len,
                    u_long * old_val, size_t old_val_len)
{
    int             ret;

    /** Check to see that we were called legally */
    if (!val)
        return SNMP_ERR_GENERR;

    /** Check the incoming type for correctness */
    if (type != ASN_UNSIGNED)
        return SNMP_ERR_WRONGTYPE;

    if (!(*val == IFX_CM_ON ||
          *val == IFX_CM_OFF) )
        return SNMP_ERR_WRONGVALUE;

    return SNMP_ERR_NOERROR;
}
