/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : RTP MIB
 *        Creator : Sharon Tseng
 *        File    : rtpSessionTable_access.c
 *        Abstract: 
 *                  
 *        Date    : 12-May-2005
 *        Ref. Doc: RFC 2959
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */
/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
*/
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "rtpSessionTable_access.h"

/*
 * ===========================================================================
 *                          GLOBAL DEFINITIONS
 * ===========================================================================
*/
static unsigned int         nEntryNum = 0;
static x_IFX_CM_Msg         xCmMsg;
static int                  nIfIdx = 0;

/*
 * ===========================================================================
 *                          LOCAL FUNCTIONS
 * ===========================================================================
 */
void *
ifxGetRtpSessionCount()
{
    /* printf("**** ifxGetRtpSessionCount ****\n"); */
    memset (&xMibMsg, 0x00, sizeof(IFX_MIB_MSG_S));
    memset (&xCmMsg, 0x00, sizeof(x_IFX_CM_Msg));

   	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
	xCmMsg.ucInfoType = IFX_CM_RTP_MIB_CFG;
	xCmMsg.ucChannel = 0;
	xCmMsg.uxData.xRtpMibCfg.ucTableType = IFX_CM_RTP_SESSION_TABLE;

    if (IFX_CM_RecvDataFromCM (&xCmMsg) != IFX_CM_SUCCESS)
    {
        snmp_log(LOG_ERR, "Fail to receive data from CM\n");
        return NULL;
    }

    nEntryNum = xCmMsg.uxData.xRtpMibCfg.ucNoOfRows;

    if (nEntryNum > 0)
    {
        xMibMsg.nType = IFX_CM_RTP_SESSION_TABLE;
        xMibMsg.nCount = nEntryNum;
        xMibMsg.nPSize = sizeof(RTPSESSIONENTRY_S *);
        xMibMsg.nSize = sizeof(RTPSESSIONENTRY_S);

        ifx_MIB_Dalloc();
	}
}

netsnmp_variable_list *
rtpSessionTable_set_indexes(RTPSESSIONENTRY_S *datainfo,
                            netsnmp_variable_list *put_index_data)
{
    /* printf("**** rtpSessionTable_set_indexes ****\n"); */
    netsnmp_variable_list   *vptr;

    /* rtpSessionIndex */
    vptr = put_index_data;
    snmp_set_var_value(vptr, (u_char *) &datainfo->rtpSessionIndex ,
                       sizeof(datainfo->rtpSessionIndex) );

    return put_index_data;
}

RTPSESSIONENTRY_S  **
rtpSessionTable_get_data(void)
{
    unsigned int     net;
    unsigned char    addr[MAX_DATA_LEN];
    int              i = 0, p = 0, n = 0;
    int              nInterfaceNum = ifx_GetNoInterfaces();
    oid              oDomain[] = { 1, 3, 6, 1, 2, 1, 100, 1, 1 };

    ifxGetRtpSessionCount();

    for ( i = 1; i <= nInterfaceNum; i++)
    {
        p = ifx_GetType(i);
        n = ifx_GetAdminStatus(i);
        if (p != 0 && p == IFTYPE_ETHERNET_CSMACD && n != 0)
        {
            nIfIdx = i;
            break;
        }
    }

    for ( i = 0; i < nEntryNum; i++)
    {
	    pstRtpSessCfg[i]->rtpSessionIndex = i;

        memset (&xCmMsg, 0x00, sizeof(x_IFX_CM_Msg));

       	xCmMsg.ucMsgType = IFX_CM_GET_REQ;
    	xCmMsg.ucInfoType = IFX_CM_RTP_MIB_CFG;
    	xCmMsg.ucChannel = 0;
    	xCmMsg.uxData.xRtpMibCfg.ucTableType = IFX_CM_RTP_SESSION_TABLE;

        if (IFX_CM_RecvDataFromCM (&xCmMsg) != IFX_CM_SUCCESS)
        {
            snmp_log(LOG_ERR, "Fail to receive data from CM\n");
            return NULL;
        }

        pstRtpSessCfg[i]->rtpSessionIndex = xCmMsg.uxData.xRtpMibCfg.ucNoOfRows;

        /* udpIpv4(1) */
        pstRtpSessCfg[i]->rtpSessionDomain = oDomain;

        memset (addr, 0x00, MAX_DATA_LEN);
        net = xCmMsg.uxData.xRtpMibCfg.uxMIBTable.axSessionTable[0].uiRemIpAddr;
        sprintf(addr, "%d.%d.%d.%d",
                (net >> 24) & 0xff,
                (net >> 16) & 0xff,
                (net >> 8) & 0xff,
                (net & 0xff));
        strcpy (pstRtpSessCfg[i]->rtpSessionRemAddr, addr);

        memset (addr, 0x00, MAX_DATA_LEN);
        net = xCmMsg.uxData.xRtpMibCfg.uxMIBTable.axSessionTable[0].uiLocIpAddr;
        sprintf(addr, "%d.%d.%d.%d",
                (net >> 24) & 0xff,
                (net >> 16) & 0xff,
                (net >> 8) & 0xff,
                (net & 0xff));
        strcpy (pstRtpSessCfg[i]->rtpSessionLocAddr, addr);

        pstRtpSessCfg[i]->rtpSessionIfIndex = nIfIdx;
        net = xCmMsg.uxData.xRtpMibCfg.uxMIBTable.axSessionTable[0].uiSenderJoins;
        pstRtpSessCfg[i]->rtpSessionSenderJoins = net;
        net = xCmMsg.uxData.xRtpMibCfg.uxMIBTable.axSessionTable[0].uiReceiverJoins;
        pstRtpSessCfg[i]->rtpSessionReceiverJoins = net;
        net = xCmMsg.uxData.xRtpMibCfg.uxMIBTable.axSessionTable[0].uiNoByes;
        pstRtpSessCfg[i]->rtpSessionByes = net;
        net = xCmMsg.uxData.xRtpMibCfg.uxMIBTable.axSessionTable[0].uiStartTime;
        pstRtpSessCfg[i]->rtpSessionStartTime = net;
        pstRtpSessCfg[i]->rtpSessionMonitor = RTPSESSIONMONITOR_TRUE;
        pstRtpSessCfg[i]->rtpSessionRowStatus = ROWSTATUS_ACTIVE;
    }
}

/** returns the first data point within the rtpSessionTable table data.

    Set the my_loop_context variable to the first data point structure
    of your choice (from which you can find the next one).  This could
    be anything from the first node in a linked list, to an integer
    pointer containing the beginning of an array variable.

    Set the my_data_context variable to something to be returned to
    you later that will provide you with the data to return in a given
    row.  This could be the same pointer as what my_loop_context is
    set to, or something different.

    The put_index_data variable contains a list of snmp variable
    bindings, one for each index in your table.  Set the values of
    each appropriately according to the data matching the first row
    and return the put_index_data variable at the end of the function.
*/
netsnmp_variable_list *
rtpSessionTable_get_first_data_point(void **my_loop_context,
                                     void **my_data_context,
                                     netsnmp_variable_list *
                                     put_index_data,
                                     netsnmp_iterator_info *mydata)
{
    /* printf("**** rtpSessionTable_get_first_data_point ****\n"); */
    int     *position;

    /* we could do this with a file-static variable, but for learning
       purposes we'll use memory allocation to demonstrate simplistic
       freeing of a loop_context */
    position = (int *)malloc(sizeof(int));
    if (!position)
        return NULL;

    rtpSessionTable_get_data();

    if (!pstRtpSessCfg)
    {
        snmp_log(LOG_ERR, "rtpSessionTable: None of row for this table.\n");
        free(position);
        return NULL;
    }

    /* We use the positinonal count as our loop context */
    *position = 0;
    *my_loop_context = position;

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = pstRtpSessCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return rtpSessionTable_set_indexes(pstRtpSessCfg[*position],
                                       put_index_data);
}

/** functionally the same as rtpSessionTable_get_first_data_point, but
   my_loop_context has already been set to a previous value and should
   be updated to the next in the list.  For example, if it was a
   linked list, you might want to cast it to your local data type and
   then return my_loop_context->next.  The my_data_context pointer
   should be set to something you need later and the indexes in
   put_index_data updated again. */
netsnmp_variable_list *
rtpSessionTable_get_next_data_point(void **my_loop_context,
                                    void **my_data_context,
                                    netsnmp_variable_list * put_index_data,
                                    netsnmp_iterator_info *mydata)
{
    /* printf("**** rtpSessionTable_get_next_data_point ****\n"); */
    int *position = (int *) *my_loop_context;

    /* make sure we were called correctly */
    if (!position)
        return NULL;
    
    /* go to the next entry in the list */
    (*position)++;

    /* Are we beyond the end? */
    if (*position >= nEntryNum)
    {
        /* End of entry.  stop here by returning NULL */
        free(position);
        ifxGetRtpSessionCount();
        *my_loop_context = NULL;
        *my_data_context = NULL;
        return NULL;
    }

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = pstRtpSessCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return rtpSessionTable_set_indexes(pstRtpSessCfg[*position],
                                       put_index_data);
}

/** Create a data_context for non-existent rows that SETs are performed on.
 *  return a void * pointer which will be passed to subsequent get_XXX
 *  and set_XXX functions for data retrival and modification during
 *  this SET request.
 *
 *  The indexs are encoded (in order) into the index_data pointer if it
 *  would be helpful to use that information.
 */
void           *
rtpSessionTable_create_data_context(netsnmp_variable_list * index_data)
{
    return NULL;                /* XXX: you likely want to return a real pointer */
}

/** If the implemented set_* functions don't operate directly on the
   real-live data (which is actually recommended), then this function
   can be used to take a given my_data_context pointer and "commit" it
   to whereever the modified data needs to be put back to.  For
   example, if this was a routing table you could publish the modified
   routes back into the kernel at this point.

   new_or_del will be set to 1 if new, or -1 if it should be deleted
   or 0 if it is just a modification of an existing row.

   If you free the data yourself, make sure to *my_data_context = NULL */
int
rtpSessionTable_commit_row(void **my_data_context, int new_or_del)
{
    /** Add any necessary commit code here */
    /*
     */

    /*
     * return no errors.  And there shouldn't be any!!!  Ever!!!  You
     * should have checked the values long before this. 
     */
    return SNMP_ERR_NOERROR;
}


/*
 * User-defined data access functions (per column) for data in table rtpSessionTable 
 */
/*
 * NOTE:
 * - these get_ routines MUST return data that will not be freed (ie,
 *   use static variables or persistent data).  It will be copied, if
 *   needed, immediately after the get_ routine has been called.
 * - these SET routines must copy the incoming data and can not take
 *   ownership of the memory passed in by the val pointer.
 */

/** get_rtpSessionDomain: return a data pointer to the data for the rtpSessionDomain column and set
         ret_len to its proper size in bytes. */
long            *
get_rtpSessionDomain(void *data_context, size_t * ret_len)
{
    RTPSESSIONENTRY_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->rtpSessionDomain);
    return &datainfo->rtpSessionDomain;
}

#ifdef IFX_RTP_WRITABLE
/** set_rtpSessionDomain: Set the value of the rtpSessionDomain column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_rtpSessionDomain(void *data_context, long * val, size_t val_len)
{
    RTPSESSIONENTRY_S   *datainfo = data_context;

    if (datainfo->rtpSessionRowStatus == ROWSTATUS_ACTIVE)
    {
        SNMP_ERR_GENERR;
    }
    else
    {
    }

    return SNMP_ERR_NOERROR;      /** XXX: change if an error occurs */
}
#endif /* #ifdef IFX_RTP_WRITABLE */

/** get_rtpSessionRemAddr: return a data pointer to the data for the rtpSessionRemAddr column and set
         ret_len to its proper size in bytes. */
unsigned char           *
get_rtpSessionRemAddr(void *data_context, size_t * ret_len)
{
    RTPSESSIONENTRY_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->rtpSessionRemAddr);
    return (unsigned char *) &datainfo->rtpSessionRemAddr;
}

#ifdef IFX_RTP_WRITABLE
/** set_rtpSessionRemAddr: Set the value of the rtpSessionRemAddr column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_rtpSessionRemAddr(void *data_context, unsigned char *val, size_t val_len)
{
	return SNMP_ERR_NOERROR;
}
#endif /* #ifdef IFX_RTP_WRITABLE */

/** get_rtpSessionLocAddr: return a data pointer to the data for the rtpSessionLocAddr column and set
         ret_len to its proper size in bytes. */
unsigned char           *
get_rtpSessionLocAddr(void *data_context, size_t * ret_len)
{
    RTPSESSIONENTRY_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->rtpSessionLocAddr);
    return (unsigned char *) &datainfo->rtpSessionLocAddr;
}

/** XXX: return a data pointer to the data for the rtpSessionIfIndex column and set
         ret_len to its proper size in bytes. */
long           *
get_rtpSessionIfIndex(void *data_context, size_t * ret_len)
{
    RTPSESSIONENTRY_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->rtpSessionIfIndex);
    return &datainfo->rtpSessionIfIndex;
}

#ifdef IFX_RTP_WRITABLE
/** set_rtpSessionIfIndex: Set the value of the rtpSessionIfIndex column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_rtpSessionIfIndex(void *data_context, long *val, size_t val_len)
{
    return SNMP_ERR_NOERROR;      /** XXX: change if an error occurs */
}
#endif /* #ifdef IFX_RTP_WRITABLE */

/** get_rtpSessionSenderJoins: return a data pointer to the data for the rtpSessionSenderJoins column and set
         ret_len to its proper size in bytes. */
unsigned int         *
get_rtpSessionSenderJoins(void *data_context, size_t * ret_len)
{
    RTPSESSIONENTRY_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->rtpSessionSenderJoins);
    return &datainfo->rtpSessionSenderJoins;
}

/** get_rtpSessionReceiverJoins: return a data pointer to the data for the rtpSessionReceiverJoins column and set
         ret_len to its proper size in bytes. */
unsigned int         *
get_rtpSessionReceiverJoins(void *data_context, size_t * ret_len)
{
    RTPSESSIONENTRY_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->rtpSessionReceiverJoins);
    return &datainfo->rtpSessionReceiverJoins;
}

/** get_rtpSessionByes: return a data pointer to the data for the rtpSessionByes column and set
         ret_len to its proper size in bytes. */
unsigned int         *
get_rtpSessionByes(void *data_context, size_t * ret_len)
{
    RTPSESSIONENTRY_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->rtpSessionByes);
    return &datainfo->rtpSessionByes;
}

/** get_rtpSessionStartTime: return a data pointer to the data for the rtpSessionStartTime column and set
         ret_len to its proper size in bytes. */
unsigned int         *
get_rtpSessionStartTime(void *data_context, size_t * ret_len)
{
    RTPSESSIONENTRY_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->rtpSessionStartTime);
    return &datainfo->rtpSessionStartTime;
}

/** get_rtpSessionMonitor: return a data pointer to the data for the rtpSessionMonitor column and set
         ret_len to its proper size in bytes. */
long           *
get_rtpSessionMonitor(void *data_context, size_t * ret_len)
{
    RTPSESSIONENTRY_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->rtpSessionMonitor);
    return &datainfo->rtpSessionMonitor;
}

/** get_rtpSessionRowStatus: return a data pointer to the data for the rtpSessionRowStatus column and set
         ret_len to its proper size in bytes. */
long           *
get_rtpSessionRowStatus(void *data_context, size_t * ret_len)
{
    RTPSESSIONENTRY_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->rtpSessionRowStatus);
    return &datainfo->rtpSessionRowStatus;
}

#ifdef IFX_RTP_WRITABLE
/** set_rtpSessionRowStatus: Set the value of the rtpSessionRowStatus column and return
         SNMPERR_SUCCESS on success
         SNMPERR_XXX     for SNMP deterministic error codes
         SNMPERR_GENERR  on generic failures (a last result response). */
int
set_rtpSessionRowStatus(void *data_context, long *val, size_t val_len)
{
    return SNMP_ERR_NOERROR;      /** XXX: change if an error occurs */
}
#endif /* #ifdef IFX_RTP_WRITABLE */
