/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : RTP MIB
 *        Creator : Sharon Tseng
 *        File    : rtpSessionTable_checkfns_local.c
 *        Abstract: 
 *                  
 *        Date    : 12-May-2005
 *        Ref. Doc: RFC 2959
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.check_values_local.conf,v 5.1 2003/05/30 23:53:15 hardaker Exp $
 */

/*
 * standard headers 
 */
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include "rtpSessionTable_checkfns.h"

/** Decides if an incoming value for the rtpSessionDomain mib node is legal, from a local implementation specific viewpoint.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_rtpSessionDomain_local(int type, oid * val, size_t val_len,
                             oid * old_val, size_t old_val_len)
{
    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the rtpSessionRemAddr mib node is legal, from a local implementation specific viewpoint.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_rtpSessionRemAddr_local(int type, char *val, size_t val_len,
                              char *old_val, size_t old_val_len)
{
    if (IFX_ValidateIpAddress(val) < 0)
    {
        snmp_log(LOG_ERR, "Please refer to the related MIB file.\n");
        return SNMP_ERR_WRONGVALUE;
    }

    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the rtpSessionIfIndex mib node is legal, from a local implementation specific viewpoint.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_rtpSessionIfIndex_local(int type, long *val, size_t val_len,
                              long *old_val, size_t old_val_len)
{
    return SNMP_ERR_NOERROR;
}

/** Decides if an incoming value for the rtpSessionRowStatus mib node is legal, from a local implementation specific viewpoint.
 *  @param type    The incoming data type.
 *  @param val     The value to be checked.
 *  @param val_len The length of data stored in val (in bytes).
 *  @return 0 if the incoming value is legal, an SNMP error code otherwise.
 */
int
check_rtpSessionRowStatus_local(int type, long *val, size_t val_len,
                                long *old_val, size_t old_val_len)
{
    return SNMP_ERR_NOERROR;
}
