/*
 * watcher.h 
 */
#ifndef NETSNMP_WATCHER_H
#define NETSNMP_WATCHER_H

#ifdef __cplusplus
extern "C" {
#endif

#define WATCHER_FIXED_SIZE    0x01
#define WATCHER_MAX_SIZE      0x02

typedef struct netsnmp_watcher_info_s {
    void     *data;
    size_t    data_size;
    size_t    max_size;
    u_char    type;
    int       flags;
} netsnmp_watcher_info;

int netsnmp_register_watched_instance( netsnmp_handler_registration *reginfo,
                                       netsnmp_watcher_info         *winfo);
int netsnmp_register_watched_scalar(   netsnmp_handler_registration *reginfo,
                                       netsnmp_watcher_info         *winfo);
int netsnmp_register_watched_timestamp(netsnmp_handler_registration *reginfo,
                                       marker_t timestamp);
int netsnmp_register_watched_spinlock(netsnmp_handler_registration *reginfo,
                                      int *spinlock);    

#define WATCHER_HANDLER_NAME "watcher"

netsnmp_mib_handler  *netsnmp_get_watcher_handler(void);
netsnmp_watcher_info *netsnmp_create_watcher_info(void *, size_t, u_char, int);
Netsnmp_Node_Handler  netsnmp_watcher_helper_handler;

netsnmp_mib_handler  *netsnmp_get_watched_timestamp_handler(void);
Netsnmp_Node_Handler  netsnmp_watched_timestamp_handler;

netsnmp_mib_handler  *netsnmp_get_watched_spinlock_handler(void);
Netsnmp_Node_Handler  netsnmp_watched_spinlock_handler;

/*<<sharont20050815 add */
typedef struct _netsnmp_helper_info {
    void     *data;
    size_t    data_size;
    size_t    max_size;
    size_t    min_size;
    u_char    type;
    int       flags;
} netsnmp_helper_info;

#define HELPER_FIXED_SIZE       0x0001
#define HELPER_CHECK_MAX        0x0002
#define HELPER_CHECK_MAX_MIN    0x0004
#define HELPER_MEMSET           0x0100
#define HELPER_NOACCESS         0x0200

#define IFX_MIB_SET_NAME    "ifx_mib_set"

int ifx_helper(netsnmp_mib_handler *handler,
              netsnmp_handler_registration *reginfo,
              netsnmp_agent_request_info *reqinfo,
              netsnmp_request_info *requests,
              netsnmp_helper_info *winfo);
/*>>sharont20050815 add */

#ifdef __cplusplus
}
#endif

#endif /** NETSNMP_WATCHER_H */
